﻿/* The copyright in this software is being made available under the BSD
* License, included below. This software may be subject to other third party
* and contributor rights, including patent rights, and no such rights are
* granted under this license.
*
* Copyright (c) 2010-2019, ITU/ISO/IEC
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  * Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*  * Redistributions in binary form must reproduce the above copyright notice,
*    this list of conditions and the following disclaimer in the documentation
*    and/or other materials provided with the distribution.
*  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
*    be used to endorse or promote products derived from this software without
*    specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*/

/** \file     MipData.h
\brief    weight and bias data for matrix-based intra prediction (MIP)
*/

#if JVET_O0925_MIP_SIMPLIFICATIONS
ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipMatrix4x4[18][16][4]) =
{
  {
    { 37,   59,   77,   28 },
    { 32,   92,   85,   25 },
    { 31,   69,  100,   24 },
    { 33,   36,  106,   29 },
    { 24,   49,  104,   48 },
    { 24,   21,   94,   59 },
    { 29,    0,   80,   72 },
    { 35,    2,   66,   84 },
    { 32,   13,   35,   99 },
    { 39,   11,   34,  103 },
    { 45,   21,   34,  106 },
    { 51,   24,   40,  105 },
    { 50,   28,   43,  101 },
    { 56,   32,   49,  101 },
    { 61,   31,   53,  102 },
    { 61,   32,   54,  100 }
  },
  {
    { 18,   16,   72,    2 },
    { 16,   19,   55,    7 },
    { 12,   72,   34,   14 },
    {  0,   84,   13,   21 },
    { 20,   19,   65,   54 },
    { 18,   19,   48,   65 },
    { 15,   23,   31,   73 },
    { 10,   27,   18,   76 },
    { 20,   21,   18,   87 },
    { 19,   21,   19,   87 },
    { 20,   20,   22,   85 },
    { 20,   20,   25,   84 },
    { 20,   21,   24,   82 },
    { 20,   20,   24,   82 },
    { 20,   22,   24,   82 },
    { 19,   23,   24,   82 }
  },
  {
    {  8,    7,   62,   10 },
    {  7,    0,   33,    9 },
    {  7,   12,    2,    6 },
    {  7,   63,    3,    6 },
    {  7,    7,   73,    6 },
    {  7,    8,   71,    9 },
    {  7,    1,   50,    9 },
    {  7,    9,   14,    7 },
    {  8,    7,   55,   22 },
    {  7,    7,   72,    5 },
    {  7,    9,   74,    7 },
    {  7,    3,   62,    9 },
    {  6,    6,    2,   77 },
    {  7,    6,   33,   45 },
    {  7,    7,   62,   14 },
    {  7,    8,   70,    8 }
  },
  {
    { 27,   27,   38,   28 },
    { 27,   30,   28,   28 },
    { 27,   58,   30,   26 },
    { 26,   66,   31,   25 },
    { 27,   26,   51,   27 },
    { 27,   37,   39,   26 },
    { 26,   64,   35,   26 },
    { 21,   63,   30,   31 },
    { 27,   26,   39,   47 },
    { 19,   43,   30,   51 },
    {  9,   56,   21,   54 },
    {  5,   50,   15,   56 },
    { 18,   27,   11,   72 },
    {  5,   45,   13,   64 },
    {  0,   48,   15,   59 },
    {  2,   48,   15,   58 }
  },
  {
    { 27,   19,   44,   22 },
    { 27,   35,   23,   27 },
    { 28,   88,   29,   28 },
    { 26,   91,   27,   27 },
    { 22,   21,   87,   25 },
    { 19,   22,   46,   20 },
    { 22,   69,   26,   20 },
    { 25,   87,   29,   23 },
    { 22,   23,   40,   81 },
    { 10,   16,   46,   66 },
    {  1,   17,   17,   50 },
    {  8,   37,    3,   40 },
    { 23,   25,   21,   92 },
    { 18,   24,   24,   91 },
    { 11,   16,   23,   88 },
    {  2,   11,    0,   81 }
  },
  {
    { 28,   28,   57,   29 },
    { 28,   27,   54,   29 },
    { 28,   32,   49,   28 },
    { 28,   45,   44,   28 },
    { 28,   29,   60,   27 },
    { 28,   30,   60,   29 },
    { 27,   29,   60,   29 },
    { 28,   29,   59,   30 },
    { 28,   29,   52,   36 },
    { 28,   29,   58,   28 },
    { 29,   30,   59,   27 },
    { 27,   33,   57,   28 },
    { 27,   28,   16,   71 },
    { 27,   28,   23,   65 },
    { 19,   29,   38,   47 },
    {  0,   35,   54,   20 }
  },
  {
    { 57,   57,   83,   54 },
    { 55,   55,   78,   53 },
    { 56,   70,   70,   54 },
    { 47,   97,   60,   52 },
    { 56,   57,   82,   64 },
    { 55,   56,   83,   62 },
    { 54,   66,   80,   59 },
    { 22,   79,   59,   43 },
    { 56,   56,   60,   83 },
    { 59,   58,   60,   86 },
    { 38,   54,   58,   73 },
    {  1,   62,   57,   35 },
    { 55,   56,   55,   88 },
    { 54,   54,   53,   89 },
    { 17,   40,   47,   70 },
    {  0,   60,   54,   38 }
  },
  {
    { 13,   10,   73,   12 },
    { 13,    3,   54,   15 },
    { 13,    0,   29,   14 },
    { 13,   22,   13,   13 },
    { 13,   13,   80,   10 },
    { 12,   14,   86,    7 },
    { 11,   11,   84,    8 },
    { 12,    3,   68,   11 },
    { 13,   12,   30,   59 },
    { 12,   10,   45,   43 },
    { 11,   11,   63,   26 },
    {  9,   11,   75,   15 },
    { 10,   10,    6,   83 },
    {  8,    9,    6,   83 },
    {  7,    8,    9,   78 },
    {  2,    5,   21,   63 }
  },
  {
    { 47,   46,   72,   50 },
    { 47,   45,   46,   57 },
    { 46,   69,   38,   51 },
    { 46,   80,   45,   49 },
    { 47,   48,   58,   68 },
    { 47,   45,   53,   72 },
    { 47,   57,   40,   64 },
    { 40,   76,   38,   50 },
    { 47,   47,   52,   73 },
    { 47,   47,   55,   72 },
    { 47,   48,   51,   74 },
    { 16,   56,   40,   51 },
    { 46,   46,   54,   72 },
    { 48,   48,   54,   72 },
    { 39,   43,   53,   71 },
    {  0,   35,   52,   51 }
  },
  {
    { 16,   39,   85,    0 },
    { 15,   49,   42,   39 },
    { 13,   30,   22,   66 },
    { 13,   18,   19,   74 },
    { 12,   19,   24,   73 },
    { 13,   11,   13,   83 },
    { 13,   12,   18,   78 },
    { 13,   15,   19,   75 },
    { 14,   15,   14,   78 },
    { 14,   16,   19,   75 },
    { 13,   17,   18,   75 },
    { 12,   17,   18,   75 },
    { 14,   16,   19,   75 },
    { 13,   16,   18,   76 },
    { 13,   16,   18,   76 },
    { 12,   16,   19,   75 }
  },
  {
    { 41,   37,   70,   35 },
    { 37,   27,   43,   37 },
    { 39,   74,   38,   38 },
    { 41,  113,   42,   40 },
    { 38,   40,  105,   43 },
    { 36,   32,   85,   38 },
    { 27,   28,   50,   34 },
    { 21,   83,   37,   31 },
    { 38,   39,   43,  102 },
    { 37,   39,   47,  100 },
    { 26,   27,   40,   94 },
    {  0,   25,   13,   78 },
    { 38,   39,   37,  105 },
    { 38,   40,   37,  105 },
    { 39,   42,   40,  106 },
    { 31,   35,   38,  102 }
  },
  {
    { 20,   20,   61,    8 },
    { 15,   13,   36,   10 },
    { 15,   15,   28,   12 },
    { 19,   51,   25,   14 },
    { 17,   19,   76,   39 },
    { 12,   17,   61,   40 },
    {  3,    7,   31,   42 },
    {  0,    1,    4,   46 },
    { 19,   20,   22,   85 },
    { 18,   20,   22,   86 },
    { 16,   21,   23,   85 },
    { 13,   19,   17,   84 },
    { 21,   21,   21,   84 },
    { 21,   22,   22,   83 },
    { 22,   22,   22,   84 },
    { 22,   23,   23,   83 }
  },
  {
    { 16,   14,   75,    3 },
    { 16,   43,   57,   16 },
    { 14,   63,   20,   43 },
    { 18,   46,    0,   65 },
    { 17,   20,   54,   52 },
    { 17,   22,   23,   76 },
    { 19,   17,   15,   83 },
    { 22,   17,   17,   82 },
    { 18,   17,   11,   84 },
    { 20,   18,   14,   83 },
    { 21,   20,   16,   81 },
    { 23,   21,   16,   81 },
    { 20,   18,   18,   80 },
    { 22,   19,   17,   81 },
    { 23,   20,   16,   82 },
    { 24,   20,   16,   82 }
  },
  {
    {  7,    6,   82,    0 },
    {  7,    4,   83,    0 },
    {  7,    2,   83,    0 },
    {  7,    3,   80,    0 },
    {  7,    8,   59,   16 },
    {  7,    8,   58,   17 },
    {  7,    8,   58,   17 },
    {  7,    7,   57,   18 },
    {  7,    7,    7,   70 },
    {  7,    7,    7,   71 },
    {  7,    7,    6,   71 },
    {  7,    8,    7,   70 },
    {  8,    7,    8,   71 },
    {  8,    7,    8,   70 },
    {  8,    7,    8,   70 },
    {  8,    7,    9,   69 }
  },
  {
    { 44,   41,   64,   43 },
    { 46,   60,   52,   42 },
    { 46,   81,   42,   53 },
    { 35,   71,   33,   65 },
    { 48,   51,   72,   50 },
    { 44,   65,   49,   65 },
    { 24,   56,   34,   71 },
    {  8,   38,   35,   66 },
    { 43,   50,   40,   80 },
    { 16,   39,   37,   71 },
    {  0,   28,   43,   61 },
    {  2,   29,   44,   60 },
    { 16,   33,   38,   71 },
    {  0,   25,   44,   58 },
    {  2,   26,   44,   60 },
    {  4,   28,   43,   61 }
  },
  {
    { 66,   86,   97,   69 },
    { 66,   99,   93,   67 },
    { 67,  100,   92,   68 },
    { 66,  104,   90,   67 },
    { 65,   94,  100,   63 },
    { 68,   98,   94,   70 },
    { 66,   99,   95,   67 },
    { 65,  102,   94,   66 },
    { 66,   86,  103,   67 },
    { 62,   98,  101,   55 },
    { 66,  101,   95,   66 },
    { 65,  102,   95,   66 },
    { 25,   69,   56,  123 },
    {  0,   91,   94,   43 },
    { 46,  100,  102,   50 },
    { 65,  100,   97,   65 }
  },
  {
    { 22,   20,   51,   22 },
    { 21,   22,   51,   22 },
    { 21,   29,   50,   22 },
    { 21,   32,   48,   22 },
    { 21,   23,   53,   22 },
    { 21,   24,   53,   22 },
    { 21,   23,   53,   22 },
    { 21,   24,   53,   22 },
    { 24,   24,   47,   28 },
    { 24,   24,   48,   27 },
    { 23,   25,   48,   26 },
    { 22,   25,   48,   26 },
    { 12,   16,    0,   71 },
    {  7,   14,    1,   67 },
    {  4,   14,    2,   64 },
    {  4,   13,    4,   63 }
  },
  {
    { 31,   29,   42,   33 },
    { 29,   42,   11,   47 },
    { 26,   63,   32,   31 },
    { 30,   49,   48,   26 },
    { 28,   30,   21,   56 },
    { 12,   46,   14,   37 },
    { 21,   52,   51,   18 },
    { 31,   38,   53,   29 },
    { 21,   37,   20,   52 },
    {  0,   42,   39,   10 },
    { 23,   38,   55,   22 },
    { 32,   36,   52,   33 },
    { 17,   45,   41,   27 },
    {  8,   37,   48,    8 },
    { 25,   33,   52,   27 },
    { 31,   36,   52,   32 }
  }
};

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t  mipOffsetMatrix4x4[18]) =
{ 34,   21,    7,   27,   27,   28,   56,   13,   47,   15,   40,   21,   16,    7,   45,   66,   21,   32 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipShiftMatrix4x4[18]) =
{  6,    6,    6,    5,    6,    5,    5,    6,    5,    6,    6,    6,    6,    6,    5,    6,    5,    5 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipMatrix8x8[10][16][8]) =
{
  {
    { 16,   22,   18,   20,   72,   43,    9,   19 },
    { 16,    8,   22,   26,   56,   58,    5,   20 },
    { 15,   21,   10,   35,   35,   72,    3,   20 },
    { 13,   21,   21,   29,   18,   78,    7,   18 },
    { 15,   16,   16,   19,    3,   70,   46,    8 },
    { 13,   18,   15,   20,    4,   58,   61,    4 },
    {  9,   16,   18,   18,    8,   42,   73,    3 },
    {  6,   14,   20,   18,   13,   30,   76,    6 },
    { 14,   18,   17,   17,   19,    4,   69,   40 },
    { 10,   18,   17,   16,   19,    3,   55,   51 },
    {  4,   14,   18,   15,   17,    5,   39,   63 },
    {  3,   14,   18,   16,   16,    8,   28,   70 },
    { 12,   15,   18,   16,   16,   20,    2,   92 },
    {  8,   14,   18,   15,   15,   19,    0,   91 },
    {  5,   15,   18,   16,   14,   19,    3,   88 },
    {  5,   16,   17,   17,   15,   17,    7,   84 }
  },
  {
    { 20,   35,   18,   20,   58,   35,   18,   20 },
    { 20,   75,   26,   19,   32,   31,   20,   20 },
    { 19,    6,   93,   22,   20,   25,   21,   20 },
    { 16,   25,    0,   99,   18,   21,   21,   18 },
    { 20,   28,   20,   20,    8,   78,   30,   19 },
    { 20,   67,   22,   20,   10,   59,   27,   19 },
    { 18,    7,   93,   18,   15,   30,   25,   20 },
    { 14,   25,    1,   97,   20,   18,   22,   18 },
    { 20,   28,   19,   20,   15,   14,   81,   25 },
    { 20,   59,   20,   20,   12,   22,   65,   23 },
    { 17,    7,   93,   16,   14,   24,   34,   22 },
    { 10,   24,    3,   95,   19,   20,   20,   18 },
    { 20,   29,   20,   20,   14,   23,    8,   90 },
    { 20,   51,   19,   21,   14,   19,   15,   77 },
    { 16,    7,   88,   16,   14,   20,   21,   43 },
    {  7,   22,    6,   91,   19,   18,   20,   21 }
  },
  {
    { 12,   19,   10,   12,   81,   14,   10,   11 },
    { 12,   26,   15,   10,   79,    6,   12,   11 },
    { 11,   16,   31,   12,   69,    2,   14,   10 },
    { 11,   13,    8,   44,   54,    3,   14,   10 },
    { 11,   11,   12,   11,    1,   83,   13,    9 },
    { 11,   12,   12,   12,   11,   83,    4,   12 },
    { 11,   15,   11,   13,   24,   77,    0,   12 },
    { 11,   14,   13,   16,   38,   63,    2,   12 },
    { 11,   12,   11,   11,   14,    2,   82,   12 },
    { 11,   13,   12,   12,   10,   14,   79,    5 },
    { 11,   12,   12,   13,    6,   29,   70,    3 },
    { 11,   12,   11,   16,    3,   45,   55,    4 },
    { 11,   12,   11,   12,   10,   12,    1,   84 },
    { 11,   13,   11,   12,   12,    8,   13,   76 },
    { 11,   12,   12,   13,   14,    3,   29,   64 },
    { 11,   13,   10,   17,   15,    0,   45,   49 }
  },
  {
    { 45,   74,   48,   44,   43,   62,   46,   48 },
    { 44,   77,   65,   47,   38,   46,   51,   51 },
    { 44,   46,   90,   61,   43,   41,   49,   52 },
    { 39,   43,   36,  116,   43,   42,   45,   52 },
    { 45,   75,   49,   44,   43,   47,   72,   51 },
    { 45,   65,   72,   48,   41,   35,   60,   61 },
    { 42,   41,   82,   67,   38,   41,   47,   63 },
    { 27,   46,   28,  115,   39,   44,   40,   57 },
    { 46,   68,   51,   45,   40,   44,   59,   78 },
    { 44,   55,   77,   48,   37,   43,   45,   79 },
    { 36,   38,   71,   74,   34,   44,   40,   72 },
    {  9,   52,   24,  106,   43,   38,   42,   54 },
    { 44,   58,   54,   45,   39,   46,   45,   94 },
    { 42,   46,   76,   50,   36,   48,   40,   85 },
    { 28,   41,   57,   80,   38,   42,   40,   73 },
    {  0,   56,   24,   99,   50,   28,   46,   54 }
  },
  {
    { 16,   32,   15,   16,   60,   34,   10,   19 },
    { 16,   68,   28,   13,   31,   37,   11,   17 },
    { 15,    8,   73,   23,   15,   30,   22,   14 },
    { 15,   18,    0,   85,   11,   17,   33,   15 },
    { 16,   18,   19,   17,    9,   56,   56,    9 },
    { 15,   19,   20,   16,   13,   30,   73,   12 },
    { 15,   20,   20,   18,   13,   13,   71,   28 },
    { 16,   18,   16,   26,   12,    8,   54,   47 },
    { 17,   16,   17,   17,   17,   10,   54,   51 },
    { 18,   17,   16,   18,   16,   15,   28,   73 },
    { 18,   18,   15,   18,   16,   20,   14,   83 },
    { 19,   19,   17,   18,   15,   21,   14,   82 },
    { 18,   17,   16,   18,   17,   18,    7,   90 },
    { 19,   18,   16,   19,   16,   17,   11,   87 },
    { 20,   18,   16,   20,   17,   15,   15,   84 },
    { 21,   19,   16,   22,   17,   15,   18,   81 }
  },
  {
    { 11,    6,   13,   11,   75,    6,   12,   11 },
    { 10,    3,    8,   13,   48,    2,   13,   10 },
    { 10,   45,    1,   13,   19,    9,   12,   10 },
    { 10,   42,   37,    8,   10,   12,   11,   10 },
    { 11,   11,   10,   12,   18,   74,    6,   11 },
    { 11,   12,   10,   12,   53,   47,    2,   12 },
    { 10,    6,   10,   12,   71,   16,    9,   11 },
    { 10,   15,    6,   13,   53,    5,   13,   10 },
    { 10,   12,   10,   11,    9,   17,   77,    5 },
    { 10,   11,    9,   12,    3,   51,   50,    2 },
    { 10,   11,    9,   12,   11,   72,   18,    8 },
    { 10,   11,    9,   12,   36,   57,    7,   10 },
    { 10,   10,   10,   11,   10,   10,   16,   71 },
    {  9,   11,   10,   11,   14,    0,   56,   39 },
    {  9,   11,    9,   12,   12,    8,   76,   13 },
    {  9,   12,    9,   12,    8,   35,   57,    7 }
  },
  {
    { 23,   21,   23,   23,  101,   30,   19,   25 },
    { 22,   13,   23,   24,  101,   29,   19,   25 },
    { 22,   24,   14,   23,  101,   29,   18,   24 },
    { 22,   23,   25,   17,   98,   29,   18,   24 },
    { 23,   24,   23,   23,    0,   97,   36,   17 },
    { 22,   25,   24,   22,    1,   97,   35,   17 },
    { 22,   22,   25,   23,    1,   96,   36,   17 },
    { 22,   22,   23,   24,    3,   94,   36,   17 },
    { 22,   23,   23,   22,   31,    0,   93,   34 },
    { 22,   23,   24,   23,   31,    2,   93,   33 },
    { 22,   22,   24,   23,   31,    1,   92,   34 },
    { 22,   22,   23,   23,   30,    3,   90,   35 },
    { 23,   24,   23,   23,   19,   31,    2,  102 },
    { 23,   23,   23,   24,   19,   30,    3,  101 },
    { 23,   23,   24,   24,   19,   30,    3,  101 },
    { 23,   23,   23,   24,   19,   31,    4,  100 }
  },
  {
    { 10,    5,   10,   10,   56,    4,   11,    9 },
    {  9,   22,    6,   10,   13,    9,   10,   10 },
    {  9,   67,   22,    6,   10,   10,   10,   10 },
    {  9,    6,   68,   18,   11,    9,   11,    9 },
    { 10,   10,   10,   10,   40,   53,    3,   11 },
    {  9,    6,   10,    9,   61,    9,   10,    9 },
    {  9,   17,    6,   10,   23,    7,    9,   10 },
    {  9,   56,   15,    8,   10,   11,    9,   10 },
    { 10,    9,   11,    9,    4,   42,   54,    3 },
    {  9,   10,   11,    9,   22,   67,    8,    8 },
    { 10,    7,   11,    9,   57,   23,    7,   10 },
    {  9,   11,   10,   10,   36,    8,   10,    9 },
    { 10,   10,   11,    9,   13,    0,   41,   50 },
    {  9,    9,   11,    9,    8,   24,   64,    8 },
    { 10,   10,   11,    9,   15,   63,   18,   10 },
    {  9,   10,   11,   10,   44,   33,   10,   11 }
  },
  {
    { 21,   44,   37,   20,   24,   68,   10,   23 },
    { 21,    1,   55,   39,   14,   39,   41,   18 },
    { 21,   25,    0,   68,   18,   18,   42,   39 },
    { 20,   24,   19,   36,   19,   14,   25,   72 },
    { 21,   11,   28,   30,   18,   23,   80,   19 },
    { 20,   25,    8,   38,   21,   13,   45,   62 },
    { 20,   22,   18,   25,   19,   18,   16,   90 },
    { 19,   21,   21,   24,   19,   21,   12,   91 },
    { 21,   22,   15,   28,   21,   20,   23,   82 },
    { 20,   21,   19,   24,   20,   22,    9,   95 },
    { 19,   21,   21,   22,   20,   21,   13,   92 },
    { 19,   22,   21,   22,   19,   21,   15,   90 },
    { 20,   21,   20,   22,   21,   22,   15,   90 },
    { 20,   21,   21,   22,   20,   21,   16,   89 },
    { 19,   21,   20,   23,   19,   22,   15,   89 },
    { 18,   21,   20,   23,   19,   23,   15,   87 }
  },
  {
    { 14,   15,   18,   15,   51,   68,   39,   23 },
    { 15,    4,   10,   20,   22,   76,   51,   27 },
    { 15,   16,    1,   17,   13,   78,   55,   29 },
    { 15,   13,   24,    0,   12,   76,   55,   27 },
    { 15,    8,   10,   14,   10,   66,   72,   25 },
    { 16,   12,    8,   14,   12,   59,   75,   27 },
    { 17,   13,    9,   12,   13,   58,   75,   28 },
    { 18,   14,    8,   13,   14,   60,   71,   29 },
    { 15,   10,   11,   12,   12,   42,   79,   41 },
    { 18,   14,    8,   14,   13,   45,   79,   39 },
    { 19,   14,    8,   14,   12,   44,   81,   38 },
    { 20,   15,   10,   14,   13,   45,   78,   36 },
    { 15,   11,   12,   13,   13,   24,   73,   62 },
    { 18,   15,    8,   13,   15,   28,   89,   43 },
    { 21,   14,   10,   14,   16,   29,   85,   45 },
    { 21,   16,    9,   15,   17,   33,   78,   46 }
  }
};

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipOffsetMatrix8x8[10]) =
{ 17,   20,   11,   45,   17,   11,   23,   10,   21,   11 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipShiftMatrix8x8[10]) =
{  6,    6,    6,    6,    6,    6,    6,    6,    6,    7 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipMatrix16x16[6][64][7]) =
{
  {
    { 46,    7,   14,   92,   23,   20,   10 },
    { 32,   22,   17,   52,   50,   25,   12 },
    {  1,   36,   21,   27,   61,   30,   14 },
    {  0,   30,   27,   17,   61,   32,   17 },
    { 13,   12,   37,   13,   59,   35,   18 },
    { 14,   13,   38,   11,   56,   38,   18 },
    { 10,   27,   29,    9,   55,   39,   17 },
    { 10,   27,   32,    7,   53,   38,   17 },
    {  8,   17,   14,   15,   92,   27,   13 },
    {  2,   16,   18,    8,   84,   38,   15 },
    {  4,   12,   22,    7,   76,   44,   17 },
    {  8,    8,   25,    7,   72,   46,   18 },
    {  8,    8,   26,    8,   69,   46,   19 },
    { 10,   11,   23,    9,   68,   47,   17 },
    { 10,   11,   23,    8,   67,   47,   18 },
    { 10,   12,   26,    9,   64,   43,   20 },
    {  7,   10,   16,   11,   86,   37,   17 },
    {  7,    9,   18,    9,   73,   47,   20 },
    {  8,    8,   21,    9,   67,   50,   22 },
    {  7,    9,   22,    9,   66,   50,   22 },
    {  7,    9,   23,    8,   67,   48,   22 },
    {  8,    9,   24,    8,   67,   48,   21 },
    {  8,    9,   26,    8,   66,   49,   20 },
    {  9,    8,   29,    8,   64,   48,   20 },
    {  8,    8,   16,    8,   69,   56,   19 },
    {  6,    9,   17,    8,   64,   55,   25 },
    {  7,    8,   19,    8,   62,   53,   27 },
    {  7,    8,   21,    8,   61,   52,   28 },
    {  7,    9,   22,    7,   62,   52,   25 },
    {  7,    9,   23,    6,   62,   53,   24 },
    {  8,    7,   26,    6,   62,   52,   23 },
    {  8,    8,   28,    6,   61,   51,   22 },
    {  7,    9,   14,    7,   49,   74,   23 },
    {  7,    7,   17,    7,   51,   65,   30 },
    {  7,    8,   18,    6,   53,   57,   33 },
    {  7,    8,   20,    5,   56,   57,   31 },
    {  7,    8,   22,    6,   56,   57,   29 },
    {  8,    8,   23,    5,   57,   57,   27 },
    {  8,    7,   26,    5,   57,   56,   26 },
    {  8,    6,   27,    5,   57,   55,   25 },
    {  7,    8,   14,    6,   36,   65,   47 },
    {  7,    7,   18,    5,   44,   59,   44 },
    {  7,    7,   19,    5,   47,   59,   40 },
    {  7,    7,   20,    5,   50,   59,   35 },
    {  8,    6,   22,    5,   51,   58,   33 },
    {  8,    5,   25,    5,   51,   59,   30 },
    {  7,    6,   26,    5,   51,   59,   29 },
    {  9,    6,   27,    5,   50,   59,   28 },
    {  7,    8,   14,    6,   27,   44,   76 },
    {  6,    8,   16,    5,   38,   57,   53 },
    {  6,    7,   19,    4,   44,   63,   40 },
    {  7,    6,   21,    4,   47,   62,   37 },
    {  8,    6,   22,    4,   47,   62,   35 },
    {  8,    6,   24,    5,   46,   64,   32 },
    {  8,    6,   26,    5,   46,   63,   31 },
    {  8,    6,   28,    6,   45,   62,   30 },
    {  8,    7,   15,    6,   22,   43,   81 },
    {  6,    8,   16,    5,   32,   64,   51 },
    {  8,    8,   19,    5,   37,   66,   41 },
    {  9,    5,   21,    4,   41,   67,   36 },
    {  8,    7,   22,    5,   42,   65,   35 },
    {  8,    6,   25,    6,   42,   64,   34 },
    {  9,    5,   27,    7,   43,   63,   32 },
    {  9,    5,   29,    8,   40,   60,   34 }
  },
  {
    { 50,   47,   46,   61,   50,   45,   46 },
    { 59,   49,   47,   57,   51,   45,   46 },
    { 64,   52,   48,   55,   51,   46,   46 },
    { 58,   61,   50,   53,   51,   46,   46 },
    { 52,   66,   53,   52,   51,   46,   46 },
    { 48,   62,   62,   50,   51,   46,   46 },
    { 47,   49,   76,   49,   51,   46,   46 },
    { 45,   33,   92,   49,   52,   46,   46 },
    { 50,   48,   46,   57,   63,   45,   46 },
    { 55,   52,   48,   55,   63,   45,   46 },
    { 57,   56,   50,   53,   63,   45,   46 },
    { 55,   60,   53,   51,   63,   46,   46 },
    { 51,   60,   59,   51,   63,   46,   46 },
    { 48,   55,   69,   49,   63,   46,   46 },
    { 46,   42,   84,   48,   62,   46,   46 },
    { 43,   28,   99,   48,   61,   47,   46 },
    { 49,   49,   47,   48,   73,   47,   46 },
    { 52,   52,   49,   47,   73,   48,   46 },
    { 52,   55,   53,   47,   72,   48,   46 },
    { 51,   56,   58,   46,   72,   48,   46 },
    { 48,   54,   65,   46,   71,   48,   46 },
    { 46,   47,   76,   45,   71,   49,   46 },
    { 44,   34,   91,   44,   70,   49,   46 },
    { 41,   23,  104,   45,   68,   50,   46 },
    { 48,   48,   48,   44,   68,   59,   45 },
    { 50,   51,   51,   43,   69,   58,   45 },
    { 49,   52,   56,   43,   68,   58,   45 },
    { 48,   52,   62,   42,   68,   58,   45 },
    { 45,   48,   71,   42,   68,   58,   45 },
    { 43,   38,   84,   41,   68,   59,   45 },
    { 41,   27,   98,   41,   67,   59,   45 },
    { 38,   19,  109,   42,   66,   59,   45 },
    { 47,   47,   49,   44,   52,   74,   45 },
    { 48,   48,   53,   43,   54,   74,   45 },
    { 47,   48,   60,   43,   55,   73,   45 },
    { 45,   46,   68,   43,   55,   73,   45 },
    { 43,   40,   78,   42,   56,   72,   45 },
    { 41,   30,   91,   42,   57,   72,   45 },
    { 38,   20,  105,   41,   57,   71,   45 },
    { 36,   13,  114,   41,   57,   70,   46 },
    { 46,   47,   50,   45,   43,   77,   51 },
    { 46,   46,   56,   44,   44,   78,   51 },
    { 45,   43,   64,   43,   45,   77,   51 },
    { 43,   39,   73,   43,   45,   77,   51 },
    { 40,   31,   85,   42,   46,   77,   51 },
    { 38,   22,   98,   42,   46,   77,   51 },
    { 35,   12,  111,   42,   47,   76,   51 },
    { 33,    7,  119,   41,   48,   75,   52 },
    { 46,   46,   51,   45,   44,   57,   71 },
    { 45,   43,   59,   44,   44,   58,   70 },
    { 43,   37,   68,   43,   45,   58,   70 },
    { 40,   31,   80,   43,   45,   58,   70 },
    { 38,   22,   92,   43,   46,   58,   70 },
    { 36,   13,  105,   43,   46,   58,   70 },
    { 33,    5,  117,   42,   47,   58,   70 },
    { 31,    2,  123,   42,   48,   57,   71 },
    { 45,   41,   55,   45,   51,   24,   96 },
    { 44,   36,   64,   44,   52,   23,   97 },
    { 42,   29,   75,   43,   53,   23,   97 },
    { 39,   22,   86,   43,   52,   24,   97 },
    { 37,   14,   98,   43,   53,   24,   97 },
    { 34,    7,  109,   42,   53,   25,   97 },
    { 32,    1,  118,   41,   53,   25,   97 },
    { 30,    0,  123,   41,   53,   26,   96 }
  },
  {
    { 20,   16,   16,   76,    9,   18,   16 },
    { 37,   15,   16,   71,   11,   17,   16 },
    { 65,   13,   17,   67,   12,   17,   16 },
    { 63,   30,   15,   63,   14,   17,   16 },
    { 30,   62,   13,   57,   16,   17,   16 },
    { 14,   62,   28,   52,   18,   16,   16 },
    { 21,   22,   64,   46,   21,   15,   16 },
    { 26,    0,   81,   40,   24,   15,   17 },
    { 23,   16,   16,   69,   48,    8,   18 },
    { 28,   18,   16,   66,   50,    8,   17 },
    { 36,   17,   17,   61,   54,    7,   18 },
    { 40,   20,   17,   56,   57,    7,   18 },
    { 34,   29,   18,   50,   61,    6,   18 },
    { 27,   34,   22,   44,   64,    5,   18 },
    { 25,   22,   37,   37,   67,    5,   18 },
    { 26,    9,   51,   31,   68,    6,   18 },
    { 18,   17,   17,   17,   87,    9,   17 },
    { 19,   17,   17,   15,   88,    9,   17 },
    { 20,   18,   17,   14,   88,   10,   17 },
    { 22,   17,   18,   12,   87,   12,   17 },
    { 23,   18,   19,   11,   85,   15,   16 },
    { 23,   20,   19,   11,   83,   18,   16 },
    { 22,   19,   22,   10,   79,   22,   16 },
    { 22,   16,   28,   11,   74,   26,   15 },
    { 16,   17,   16,    7,   58,   50,   10 },
    { 17,   17,   16,    8,   53,   55,   10 },
    { 18,   17,   17,   10,   47,   60,    9 },
    { 18,   16,   17,   11,   43,   64,    9 },
    { 19,   16,   17,   12,   38,   68,    9 },
    { 20,   17,   18,   13,   35,   72,    9 },
    { 20,   17,   19,   14,   31,   74,    9 },
    { 20,   16,   21,   13,   29,   74,   11 },
    { 17,   16,   16,   16,   15,   86,   11 },
    { 18,   15,   17,   16,   13,   86,   13 },
    { 18,   16,   16,   16,   13,   84,   15 },
    { 18,   15,   17,   16,   12,   82,   18 },
    { 19,   16,   17,   16,   12,   79,   21 },
    { 18,   16,   17,   16,   12,   76,   24 },
    { 18,   16,   17,   15,   12,   73,   28 },
    { 19,   16,   19,   15,   14,   68,   31 },
    { 17,   17,   16,   17,   10,   59,   43 },
    { 17,   16,   16,   17,   10,   54,   47 },
    { 18,   16,   16,   17,   11,   48,   52 },
    { 18,   16,   16,   16,   12,   44,   56 },
    { 17,   17,   16,   16,   13,   40,   59 },
    { 17,   17,   16,   16,   13,   37,   62 },
    { 17,   17,   17,   15,   14,   34,   65 },
    { 18,   16,   18,   16,   14,   32,   66 },
    { 17,   16,   16,   15,   16,   17,   79 },
    { 17,   16,   16,   16,   16,   15,   81 },
    { 18,   16,   16,   16,   16,   14,   82 },
    { 18,   16,   16,   15,   16,   13,   83 },
    { 17,   18,   16,   15,   16,   13,   83 },
    { 17,   17,   17,   15,   16,   13,   84 },
    { 17,   17,   17,   15,   16,   13,   84 },
    { 17,   16,   18,   15,   16,   13,   83 },
    { 16,   16,   16,   16,   17,    3,   92 },
    { 17,   16,   16,   15,   17,    4,   91 },
    { 18,   17,   17,   14,   18,    4,   90 },
    { 18,   17,   16,   14,   18,    4,   91 },
    { 17,   18,   16,   15,   18,    4,   91 },
    { 17,   18,   17,   15,   18,    4,   90 },
    { 17,   17,   18,   14,   18,    4,   90 },
    { 18,   16,   19,   15,   18,    5,   89 }
  },
  {
    { 13,    9,   10,   43,   11,   12,    9 },
    { 43,    2,   11,   22,   15,   12,   10 },
    { 73,    2,   11,   16,   16,   12,    9 },
    { 52,   38,    5,   13,   16,   12,   10 },
    { 11,   71,    6,   12,   14,   13,   10 },
    {  3,   50,   35,   10,   14,   13,    9 },
    { 11,   12,   68,   11,   13,   13,   10 },
    { 13,    3,   74,   12,   11,   15,   10 },
    { 20,    9,   10,   51,   29,   11,   10 },
    { 41,    5,   10,   37,   26,   13,   10 },
    { 58,    9,   10,   23,   27,   14,    9 },
    { 41,   36,    6,   15,   24,   16,   10 },
    { 14,   57,   11,   11,   21,   18,    9 },
    {  7,   39,   37,    9,   18,   19,    9 },
    { 12,    9,   63,   10,   15,   20,    9 },
    { 15,    2,   68,   11,   12,   21,   10 },
    { 16,   11,   11,   19,   60,   11,   11 },
    { 27,   11,   11,   20,   50,   16,   10 },
    { 35,   15,   11,   17,   42,   20,   10 },
    { 29,   29,   11,   12,   35,   23,   10 },
    { 17,   37,   18,    8,   29,   26,    9 },
    { 13,   26,   35,    6,   24,   27,    9 },
    { 15,    8,   53,    7,   19,   27,   10 },
    { 16,    4,   57,    9,   14,   28,   11 },
    { 12,   11,   11,    5,   51,   36,    8 },
    { 15,   13,   12,    8,   45,   36,    9 },
    { 19,   16,   14,    9,   38,   38,    9 },
    { 19,   21,   16,    8,   32,   39,   10 },
    { 18,   22,   21,    7,   27,   39,   10 },
    { 18,   16,   31,    7,   22,   39,   11 },
    { 18,    9,   41,    6,   18,   39,   11 },
    { 19,    7,   44,    7,   15,   37,   13 },
    { 11,   12,   11,    9,   18,   64,   10 },
    { 11,   12,   13,   10,   18,   61,   11 },
    { 13,   13,   15,   10,   17,   58,   12 },
    { 15,   14,   17,   10,   16,   56,   13 },
    { 17,   14,   20,    9,   14,   55,   13 },
    { 18,   11,   26,    9,   13,   52,   14 },
    { 19,    9,   31,    8,   11,   50,   15 },
    { 19,    9,   33,    8,   10,   46,   17 },
    { 10,   11,   12,   11,    4,   59,   28 },
    { 11,   10,   13,   11,    4,   60,   26 },
    { 12,   10,   15,   11,    5,   59,   25 },
    { 14,   10,   16,   11,    5,   58,   24 },
    { 15,   10,   18,   11,    4,   57,   24 },
    { 17,    9,   21,   11,    4,   56,   24 },
    { 19,    9,   23,   10,    4,   53,   24 },
    { 19,    9,   26,   10,    5,   49,   25 },
    { 10,   10,   12,   11,    5,   27,   60 },
    { 11,    8,   14,   11,    3,   34,   54 },
    { 13,    8,   15,   12,    2,   38,   50 },
    { 13,    8,   15,   13,    1,   41,   47 },
    { 15,    8,   17,   13,    0,   42,   45 },
    { 16,    8,   18,   13,    0,   44,   43 },
    { 18,    8,   19,   12,    0,   44,   41 },
    { 19,    9,   21,   12,    1,   43,   39 },
    { 11,    8,   12,   11,    6,    9,   77 },
    { 13,    7,   13,   12,    4,   16,   72 },
    { 15,    6,   14,   13,    2,   21,   67 },
    { 15,    6,   14,   13,    1,   25,   63 },
    { 15,    7,   15,   14,    0,   27,   61 },
    { 16,    8,   15,   14,    0,   29,   58 },
    { 17,    8,   17,   14,    0,   29,   56 },
    { 18,    8,   18,   14,    1,   30,   53 }
  },
  {
    { 15,   13,   13,   55,   12,   13,   13 },
    { 21,   13,   13,   34,   14,   13,   13 },
    { 39,   12,   13,   22,   14,   13,   13 },
    { 55,   18,   12,   18,   14,   14,   13 },
    { 48,   37,   11,   16,   14,   14,   13 },
    { 23,   62,   13,   14,   14,   13,   13 },
    { 11,   53,   35,   14,   14,   13,   12 },
    { 15,   13,   72,   14,   14,   13,   12 },
    { 16,   13,   13,   63,   27,   12,   13 },
    { 17,   13,   13,   58,   19,   13,   13 },
    { 22,   13,   13,   43,   18,   13,   13 },
    { 33,   14,   12,   31,   17,   14,   13 },
    { 45,   18,   12,   24,   16,   14,   12 },
    { 44,   32,   12,   19,   15,   14,   13 },
    { 29,   49,   15,   17,   14,   14,   12 },
    { 18,   44,   33,   16,   15,   13,   12 },
    { 15,   13,   13,   32,   60,   10,   13 },
    { 16,   13,   13,   45,   44,   12,   13 },
    { 17,   14,   13,   49,   32,   13,   12 },
    { 21,   14,   13,   44,   25,   14,   12 },
    { 30,   14,   13,   37,   21,   14,   12 },
    { 39,   16,   13,   30,   18,   14,   12 },
    { 39,   27,   13,   24,   17,   14,   12 },
    { 31,   38,   16,   21,   17,   13,   12 },
    { 13,   13,   13,   13,   64,   27,   11 },
    { 14,   13,   13,   23,   61,   19,   12 },
    { 15,   14,   13,   34,   51,   16,   12 },
    { 17,   14,   13,   40,   42,   15,   12 },
    { 20,   14,   13,   40,   34,   14,   12 },
    { 27,   14,   13,   37,   29,   14,   12 },
    { 33,   16,   13,   32,   25,   13,   12 },
    { 33,   24,   14,   27,   23,   13,   12 },
    { 13,   13,   13,   13,   33,   61,    9 },
    { 13,   13,   13,   15,   47,   44,   10 },
    { 14,   13,   13,   20,   54,   31,   11 },
    { 15,   13,   13,   27,   53,   23,   11 },
    { 16,   14,   13,   32,   49,   18,   12 },
    { 19,   14,   13,   34,   43,   15,   12 },
    { 24,   14,   13,   34,   37,   14,   12 },
    { 28,   17,   13,   31,   32,   14,   12 },
    { 13,   14,   13,   15,   10,   71,   20 },
    { 13,   13,   13,   15,   22,   66,   13 },
    { 14,   13,   13,   15,   37,   53,   11 },
    { 14,   13,   13,   18,   47,   40,   11 },
    { 14,   13,   13,   23,   52,   29,   11 },
    { 15,   14,   13,   27,   51,   23,   11 },
    { 18,   14,   13,   30,   47,   19,   11 },
    { 22,   15,   13,   30,   42,   17,   12 },
    { 13,   13,   13,   14,   12,   34,   57 },
    { 13,   13,   13,   15,   14,   50,   38 },
    { 13,   13,   13,   15,   21,   58,   23 },
    { 14,   13,   13,   16,   32,   54,   16 },
    { 13,   13,   13,   18,   41,   45,   13 },
    { 13,   14,   13,   21,   47,   36,   12 },
    { 14,   14,   13,   24,   49,   28,   12 },
    { 17,   14,   13,   26,   46,   24,   12 },
    { 13,   13,   13,   13,   19,    0,   85 },
    { 13,   13,   13,   13,   20,   12,   72 },
    { 13,   13,   13,   15,   20,   30,   53 },
    { 13,   13,   13,   16,   23,   44,   35 },
    { 13,   14,   12,   17,   29,   47,   24 },
    { 13,   14,   13,   18,   36,   44,   18 },
    { 13,   14,   13,   20,   41,   38,   16 },
    { 15,   14,   14,   22,   42,   33,   15 }
  },
  {
    { 24,    9,   10,   52,   13,   10,   12 },
    { 53,    9,   10,   25,   26,    6,   13 },
    { 48,   30,    9,   11,   30,    7,   13 },
    { 15,   59,   12,    6,   25,   13,   11 },
    {  5,   48,   34,    7,   18,   19,   10 },
    { 10,   15,   62,    8,   12,   20,   13 },
    { 13,    2,   70,    8,    9,   19,   19 },
    { 13,    3,   62,    9,    6,   16,   30 },
    { 25,   14,   10,   40,   51,    0,   14 },
    { 20,   28,   11,   16,   55,    5,   13 },
    {  8,   38,   18,    6,   41,   20,   11 },
    {  5,   28,   34,    6,   23,   31,   12 },
    {  9,   12,   48,    8,   12,   33,   18 },
    { 12,    2,   53,    9,    6,   30,   28 },
    { 14,    1,   50,    9,    4,   23,   40 },
    { 14,    5,   42,    8,    4,   15,   51 },
    {  8,   20,   12,    5,   72,   12,   12 },
    {  2,   24,   19,    5,   46,   35,    9 },
    {  5,   16,   29,    9,   21,   48,   13 },
    {  9,    6,   36,   10,    9,   45,   25 },
    { 12,    3,   37,   11,    5,   36,   38 },
    { 13,    4,   34,   11,    4,   25,   51 },
    { 13,    6,   29,   10,    4,   16,   61 },
    { 13,    9,   26,   10,    6,   11,   66 },
    {  6,   14,   15,    6,   31,   60,    6 },
    {  7,   10,   22,   11,   12,   64,   15 },
    { 10,    6,   26,   13,    6,   50,   32 },
    { 11,    4,   27,   12,    5,   33,   49 },
    { 12,    5,   25,   11,    6,   20,   62 },
    { 12,    7,   22,   11,    7,   13,   69 },
    { 12,    9,   19,   11,    7,    8,   74 },
    { 12,   10,   19,   10,    8,    7,   74 },
    { 10,    9,   16,   12,    6,   67,   20 },
    { 11,    6,   20,   13,    5,   46,   41 },
    { 11,    5,   21,   12,    7,   26,   59 },
    { 11,    7,   19,   12,    9,   14,   70 },
    { 11,    8,   18,   11,   10,    8,   75 },
    { 11,    9,   16,   11,   10,    5,   78 },
    { 12,   10,   15,   11,   10,    4,   80 },
    { 11,   10,   15,   10,   10,    4,   78 },
    { 11,    9,   15,   12,    8,   34,   54 },
    { 11,    7,   17,   11,   10,   16,   69 },
    { 11,    7,   17,   11,   11,    7,   76 },
    { 11,    8,   16,   11,   11,    4,   80 },
    { 10,   10,   14,   11,   11,    3,   81 },
    { 11,   10,   13,   11,   12,    2,   82 },
    { 11,   10,   13,   11,   12,    2,   82 },
    { 11,   11,   13,   10,   12,    3,   80 },
    { 11,    9,   14,   11,   11,    8,   77 },
    { 11,    8,   14,   11,   12,    3,   81 },
    { 11,    9,   14,   11,   12,    1,   83 },
    { 10,   10,   13,   11,   12,    2,   83 },
    { 10,   11,   12,   11,   12,    2,   82 },
    { 10,   11,   12,   11,   12,    3,   82 },
    { 11,   11,   11,   11,   12,    3,   81 },
    { 11,   11,   11,   11,   13,    5,   79 },
    { 11,   10,   13,   11,   13,    2,   82 },
    { 11,    9,   13,   11,   13,    1,   83 },
    { 11,   10,   12,   11,   13,    2,   82 },
    { 10,   11,   12,   11,   12,    3,   81 },
    { 10,   11,   12,   11,   12,    4,   80 },
    { 10,   11,   11,   11,   12,    5,   80 },
    { 11,   11,   11,   11,   13,    5,   79 },
    { 11,   11,   11,   11,   12,    6,   77 }
  }
};

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipOffsetMatrix16x16[6]) =
{  8,   46,   16,   10,   13,   11 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipShiftMatrix16x16[6]) =
{  7,    5,    6,    6,    6,    6 };
#else
#include "CommonDef.h"

ALIGN_DATA( MEMORY_ALIGN_DEF_SIZE, const short mipMatrix4x4[18][16][4] )=
{
  {
    {  132,  -13,  142,  -13 },
    {  169,   66,    4,   19 },
    {  -32,  273,   -9,   29 },
    {  -66,  250,    8,    9 },
    {   -3,   20,  180,   63 },
    {    2,  123,   10,  124 },
    {  -57,  193,  -40,   89 },
    {  -17,  105,  -34,   67 },
    {  -12,   28,  -28,  273 },
    {  -39,   87,  -59,  193 },
    {  -28,   85,  -30,   82 },
    {  -12,   71,  -24,   71 },
    {    2,   10,  -58,  243 },
    {  -33,   67,  -13,   98 },
    {  -24,   74,  -10,   66 },
    {  -19,   73,  -17,   66 }
  },
  {
    {   32,  -10,  224,    6 },
    {  137,  -37,  145,    6 },
    {   93,  123,   36,    0 },
    {   -9,  273,  -10,   -5 },
    {   -9,    3,  265,   -8 },
    {  -17,   -7,  283,  -16 },
    {   -5,  -10,  267,  -16 },
    { -119,  184,  167,   -5 },
    {    6,   -4,   86,  165 },
    {    4,  -10,   45,  194 },
    {    8,  -35,   13,  221 },
    {  -35,  -15,   -4,  241 },
    {   -1,  -15, -125,  369 },
    {   -1,  -22, -125,  361 },
    {   -1,  -25, -124,  352 },
    {   14,  -41, -117,  337 }
  },
  {
    {  164,   12,  115,  -44 },
    {  244,   -5,   34,  -33 },
    {  213,   41,   19,  -24 },
    {  -86,  336,    3,  -27 },
    {  -56,    2,  262,   39 },
    {   -5,   14,  190,   24 },
    {   90,    7,   78,   17 },
    {  -51,  215,  -21,   13 },
    {   -6,   -4,    0,  262 },
    {  -22,    0,   11,  257 },
    {  -16,   -8,   15,  243 },
    {  -40,   47,  -20,  214 },
    {   -2,    3,    6,  248 },
    {   -4,    4,    7,  247 },
    {   -5,    2,   11,  249 },
    {   -1,  -12,   18,  247 }
  },
  {
    {   44,   -8,  248,  -29 },
    {  232,  -20,   46,   -4 },
    {   97,  187,  -35,    4 },
    {  -34,  279,    2,    6 },
    {  -12,    7,  200,   62 },
    {   40,  -22,  174,   62 },
    {   97,  107,   -8,   56 },
    {   -6,  271,  -47,   22 },
    {    2,    4,   24,  227 },
    {    3,   -9,   38,  223 },
    {  -20,   36,   67,  170 },
    {  -68,  209,   27,   -6 },
    {   -3,    0,    5,  251 },
    {    6,    0,    1,  249 },
    {  -11,   -7,   44,  212 },
    { -179,   87,  176,  -35 }
  },
  {
    {   89,  -18,  246,  -68 },
    {   43,   62,  167,  -25 },
    {  -52,  192,   40,   51 },
    {  -18,  179,  -69,  125 },
    {  -48,    3,  156,  140 },
    {  -38,    3,   66,  210 },
    {  -26,    1,   13,  247 },
    {  -13,    1,   -6,  253 },
    {    2,    0,  -18,  267 },
    {    0,    1,  -12,  260 },
    {   -5,    4,    1,  250 },
    {   -9,    5,    8,  246 },
    {   -6,    1,    8,  248 },
    {   -7,    2,    8,  247 },
    {  -10,    5,    5,  249 },
    {  -10,    5,    4,  248 }
  },
  {
    {   69,    2,  189,   -2 },
    {  196,  -17,   74,    1 },
    {  276,  -23,   -1,    0 },
    {  167,   92,   -4,    1 },
    {  -11,    0,  280,  -15 },
    {    2,    4,  262,  -14 },
    {   96,   -5,  168,   -5 },
    {  227,  -30,   56,   -1 },
    {    1,   -1,  147,  111 },
    {   -1,   -5,  238,   22 },
    {  -14,    0,  284,  -17 },
    {   21,    2,  246,  -17 },
    {    4,   -2,  -35,  288 },
    {    5,   -5,   21,  234 },
    {    6,   -7,  116,  140 },
    {   -1,   -5,  206,   51 }
  },
  {
    {  149,  -11,  134,  -12 },
    {  113,   82,   79,  -17 },
    {   -5,  237,   41,  -19 },
    {  -20,  266,    8,   -1 },
    {  -74,    9,  296,   22 },
    { -100,   63,  228,   60 },
    { -129,  159,   91,  132 },
    {  -71,  177,  -46,  172 },
    {  -15,   -5,   35,  242 },
    {  -20,   21,  -42,  284 },
    {  -31,   47,  -62,  242 },
    {  -35,   59,  -44,  169 },
    {   23,   22, -102,  288 },
    {    3,   46,  -57,  180 },
    {   -7,   55,  -19,  106 },
    {  -13,   60,  -10,  101 }
  },
  {
    {  183,   12,   81,  -17 },
    {  274,  -11,  -12,    0 },
    {  223,   29,    2,    5 },
    {  -22,  274,   -2,    0 },
    {    0,    1,  255,   -1 },
    {  149,    6,  115,  -19 },
    {  280,  -25,   12,  -19 },
    {  161,   91,   11,  -17 },
    {  -15,   -2,   48,  224 },
    {  -11,   -3,   84,  179 },
    {  116,   -9,    8,  129 },
    {  257,  -29,  -72,   74 },
    {    4,    1,  -17,  267 },
    {   -3,    1,  -16,  271 },
    {   -8,   -2,  -14,  272 },
    {   93,  -30,  -93,  258 }
  },
  {
    {  205,  -44,  129,  -41 },
    {  280,  -48,   41,  -32 },
    {   71,  188,   10,  -27 },
    {  -16,  266,   19,  -24 },
    {  -53,    8,  253,   40 },
    {   50,  -35,  184,   29 },
    {   69,   41,   64,   19 },
    {  -46,  232,  -35,   17 },
    {  -11,    1,    0,  260 },
    {  -21,   -1,    8,  257 },
    {  -11,  -17,    8,  245 },
    { -119,  135,  -50,  224 },
    {   -3,    2,    6,  250 },
    {   -5,    5,    7,  249 },
    {    0,   -2,   10,  251 },
    {  -36,   26,   15,  248 }
  },
  {
    {  -41,   96,  265,  -58 },
    {  -99,  156,  141,   57 },
    {  -61,   95,   49,  170 },
    {  -15,   28,   13,  230 },
    {  -49,   19,   71,  212 },
    {   -4,  -16,    7,  268 },
    {    6,  -21,   12,  263 },
    {   -2,   -6,   20,  251 },
    {    7,   -2,   -5,  259 },
    {   -1,    4,   14,  246 },
    {   -6,    9,   15,  245 },
    {   -5,    7,   15,  247 },
    {   -4,    3,   16,  247 },
    {   -4,    3,   14,  251 },
    {   -3,    3,   13,  251 },
    {   -2,    3,   15,  249 }
  },
  {
    {  145,  -30,  241, -108 },
    {  234, -111,  222, -105 },
    {  305, -175,  207, -101 },
    {  315, -178,  192,  -95 },
    {  -39,  -71,  254,  109 },
    {  -15,  -99,  257,  106 },
    {   36, -151,  258,  101 },
    {  112, -222,  250,   99 },
    {   14,  -11,  -15,  269 },
    {   12,   -9,  -12,  268 },
    {    2,   -1,   -5,  266 },
    {    1,   -6,    8,  261 },
    {   -5,   -1,   25,  242 },
    {    1,   -7,   28,  242 },
    {    6,  -12,   28,  242 },
    {   11,  -16,   29,  243 }
  },
  {
    {   38,  -15,  237,    4 },
    {   95,   22,  148,   -3 },
    {   39,  212,   21,  -20 },
    {   -2,  267,    2,  -15 },
    {  -10,    2,  258,    2 },
    {  -26,    1,  252,   26 },
    {  -70,  112,  132,   81 },
    {  -45,  242,  -78,  115 },
    {   -1,   -8,   52,  213 },
    {   -2,   -4,  -26,  273 },
    {  -30,   16,  -46,  253 },
    {  -50,   84,  -75,  169 },
    {    3,   15, -116,  321 },
    {    3,   24,  -75,  204 },
    {   15,   27,  -35,  101 },
    {   13,   30,  -16,   78 }
  },
  {
    {   21,    0,  232,    5 },
    {    3,   31,  220,    3 },
    {  -22,   75,  203,   -1 },
    {  -35,  109,  182,   -3 },
    {  -27,   20,  263,   -1 },
    {  -34,   26,  261,    2 },
    {  -36,   27,  262,    4 },
    {  -39,   33,  259,    6 },
    {  -14,   16,  235,   26 },
    {  -20,   24,  246,   11 },
    {  -29,   33,  246,    6 },
    {  -37,   41,  240,  -10 },
    {   12,  -17, -200,  435 },
    {    8,  -19, -170,  376 },
    {   -6,  -15, -120,  280 },
    {  -19,   -8,  -74,  200 }
  },
  {
    {   24,  -11,  235,   11 },
    {   84,  -32,  196,   12 },
    {   35,   74,  142,    8 },
    {  -93,  255,   92,    2 },
    {   -7,    6,  263,   -7 },
    {  -16,    6,  271,   -7 },
    {   -2,  -14,  275,   -3 },
    {  -47,   40,  262,    2 },
    {    8,   14,  158,  112 },
    {   11,   10,  184,   77 },
    {    7,   10,  205,   49 },
    {   18,   -8,  223,   29 },
    {   -5,  -34, -115,  340 },
    {   -1,  -46, -101,  313 },
    {    0,  -52,  -85,  289 },
    {   -5,  -49,  -62,  260 }
  },
  {
    {   79,   11,  177,  -16 },
    {  -33,  202,  102,   -9 },
    {  -65,  266,  -22,   92 },
    {   47,  148, -156,  202 },
    { -115,  120,  200,   68 },
    {  -34,  139,  -45,  199 },
    {   83,   29, -186,  273 },
    {  103,  -19, -204,  264 },
    {   15,   24,  -85,  295 },
    {   61,  -38, -154,  281 },
    {   46,  -48, -143,  238 },
    {   39,  -33, -143,  228 },
    {   32,  -43, -110,  275 },
    {   19,  -50, -108,  230 },
    {   17,  -43, -118,  228 },
    {   22,  -37, -128,  228 }
  },
  {
    {   21,    1,  231,    6 },
    {    4,   30,  219,    4 },
    {  -19,   72,  203,    0 },
    {  -25,  100,  182,   -2 },
    {  -23,   17,  263,   -2 },
    {  -30,   24,  260,    1 },
    {  -31,   23,  260,    3 },
    {  -32,   27,  258,    5 },
    {  -10,   14,  231,   32 },
    {  -17,   23,  246,   12 },
    {  -26,   31,  248,    4 },
    {  -32,   38,  242,  -10 },
    {    4,  -12, -193,  420 },
    {   -3,  -12, -162,  360 },
    {  -14,  -10, -113,  267 },
    {  -24,   -4,  -65,  180 }
  },
  {
    {   10,   -9,  304,  -55 },
    {   12,  -15,  305,  -56 },
    {  -14,   14,  293,  -45 },
    { -182,  186,  260,  -19 },
    {  -17,    9,  175,   89 },
    {  -14,    7,  126,  134 },
    {    3,  -11,   82,  176 },
    {   11,  -20,   50,  205 },
    {    3,   -2,  -11,  264 },
    {    3,   -2,  -15,  267 },
    {   -4,    4,  -12,  264 },
    {    3,   -2,   -4,  256 },
    {   -3,   -1,    6,  250 },
    {   -3,   -2,    9,  247 },
    {   -4,   -1,    8,  247 },
    {   -7,    2,    8,  246 }
  },
  {
    {  -23,   -3,  283,   -2 },
    {  -18,  -11,  287,   -2 },
    {   -2,  -26,  287,   -3 },
    {   -1,  -21,  282,   -4 },
    {   18,    2,  234,    3 },
    {   16,    5,  233,    3 },
    {   13,    7,  231,    5 },
    {   17,    0,  229,   10 },
    {    2,   -1,    9,  246 },
    {    2,   -1,    6,  249 },
    {    1,    1,    3,  251 },
    {   -1,    3,    3,  251 },
    {    0,    0,  -11,  267 },
    {    0,    1,  -11,  266 },
    {    1,    1,  -10,  264 },
    {    1,    1,   -9,  263 }
  }
};
ALIGN_DATA( MEMORY_ALIGN_DEF_SIZE, const short mipBias4x4[18][16] )=
{
  {   3,  10,  -3,  -4,   8,  -2,  -6,   1,  -3,  -5,  -2,  -3,  -1,   2,  -3,   1 },
  {   4,   5,   3,   4,   4,  11,  19,  25,   3,  24,  51,  70,  28,  44,  55,  63 },
  {   2,   6,   0,  29,   0,   1,   4,  33,   4,   7,   6,  15,  -1,   0,   0,   5 },
  {   1,   1,   1,   3,  -1,   2,   3,  13,   0,   1,   3,  87,   3,  -1,  16, 191 },
  {   6,   8,  24,  37,   4,  14,  19,  20,   5,   7,   6,   6,   4,   6,   6,   8 },
  {   0,   2,   3,  -1,   2,   2,   2,   4,  -1,   1,   3,   3,   0,  -1,   0,   2 },
  {  -3,  -2,  -3,  -6,   1,  -5, -11,  30, -13,  19, 114, 207,  67, 183, 255, 253 },
  {  -2,   4,  -1,   3,   1,   4,   7,   7,   1,   4,  11,  21,   1,   2,   6,  23 },
  {  12,  20,  16,  12,  11,  42,  89, 115,   4,  13,  35,  81,   4,   2,  -3,   2 },
  {  -6,   0,   3,   0,   3,   1,  -4,  -7,  -3,  -6,  -7,  -9,  -7,  -8,  -9, -10 },
  {   8,  15,  20,  21,   2,   7,  12,  16,  -1,  -3,  -6,  -8,  -5,  -7,  -8,  -9 },
  {  -6,  -4,   6,   6,   4,   7,  13,  21,   8,  11,  15,  23,  -9,  -3,  -2,  -4 },
  {  -2,  -2,   2,   4,   2,   2,  -1,  -5, -10,  -5,   3,  37,  47, 104, 190, 249 },
  {  -3,  -4,  -3,   0,   0,   2,   0,  -1, -34, -24, -15,  -5,  66,  87,  99, 106 },
  {   7,  -6, -18,  17, -20,  -6,  63, 122,   6, 113, 172, 172, 108, 173, 178, 175 },
  {  -1,  -1,  -1,  -1,   1,   1,   1,   0,  -5,  -5,  -3,   4,  11,  24,  43,  61 },
  {   6,   9,   8,  11,   0,   3,   6,  10,   2,   4,   5,   4,   4,   6,   7,   7 },
  {   1,   1,   1,   1,  -1,  -1,  -1,  -1,   0,   0,   0,   0,   0,   0,   0,   0 }
};
const int mipShiftBias4x4[18] =
{
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9
};
const int mipShiftMatrix4x4[18] =
{
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8
};
ALIGN_DATA( MEMORY_ALIGN_DEF_SIZE, const short mipMatrix8x8[10][16][8] )=
{
  {
    {   42,  -26,    8,   -1,  270,  -41,    7,   -3 },
    {  192,  -31,   -4,    1,  131,  -41,   12,   -4 },
    {  128,  146,  -21,   -3,   10,   -5,    2,   -2 },
    {   14,  136,  111,    1,   -9,    7,   -3,   -1 },
    {  -11,    2,   -2,    1,   35,  267,  -42,    5 },
    {  -34,    0,    2,    1,  197,  126,  -42,    6 },
    {   52,  -41,    8,    1,  257,  -15,   -3,   -1 },
    {  132,   15,  -18,    5,  156,  -40,   11,   -4 },
    {    3,   -1,    0,    1,  -16,   32,  272,  -36 },
    {    9,   -2,   -1,    1,  -47,  199,  129,  -32 },
    {  -13,    6,   -3,    2,   12,  268,  -11,   -4 },
    {  -15,   -6,    3,    3,  137,  167,  -35,    3 },
    {   -3,    0,   -2,    1,    4,  -15,   24,  246 },
    {   -5,    0,   -3,    2,   15,  -56,  202,  101 },
    {    1,   -1,   -3,    2,   -8,    6,  267,   -9 },
    {    5,    0,   -3,    4,  -29,  145,  152,  -18 }
  },
  {
    {    5,  192,  -40,    5,  -50,   83,   71,   -8 },
    {   -8,    9,  238,  -14,    9,  -36,   18,   40 },
    {    3,   -4,    7,  250,    0,    1,  -19,   19 },
    {    2,    3,  -34,  289,    3,   -3,   -1,   -1 },
    {  -23,   55,   97,  -21,   13,  -65,  125,   74 },
    {    4,  -26,   87,  166,   -1,    7,  -41,   60 },
    {    2,    6,  -48,  299,    1,   -4,   -3,    4 },
    {    2,    4,  -33,  288,    3,   -4,    0,    0 },
    {  -10,  -19,   84,   73,    5,    9,  -64,  177 },
    {   -2,   -8,  -29,  279,    2,    3,   -6,   16 },
    {    2,    2,  -37,  293,    2,   -4,    2,   -2 },
    {    2,    5,  -31,  285,    4,   -4,    1,   -1 },
    {   -8,  -32,    7,  202,    6,   19,  -18,   78 },
    {   -4,   -3,  -41,  288,    4,    3,   -2,   11 },
    {    2,    2,  -34,  288,    4,   -3,    4,   -4 },
    {    2,    6,  -27,  277,    6,   -3,    1,    0 }
  },
  {
    {  140,   38,   -4,    1,    8,   73,   -2,    3 },
    {  -62,  273,   15,   -4,  -17,   38,    6,    5 },
    {   -5,  -45,  294,    3,  -25,   23,    6,    6 },
    {    1,   10,  -86,  325,  -14,    7,    2,   -1 },
    {  101,   18,    2,    0, -101,  178,   60,   -2 },
    {  -66,  275,   -8,    0,  -99,   96,   49,    8 },
    {  -18,  -24,  287,  -11,  -60,   31,   32,   14 },
    {   -3,    3,  -77,  310,  -23,   -1,   11,    7 },
    {   74,    7,    5,    0,  -70,    9,  179,   53 },
    {  -76,  268,  -19,    1, -111,   31,  104,   58 },
    {  -33,   -1,  272,  -22,  -85,   24,   31,   58 },
    {   -7,   -5,  -68,  290,  -36,    4,  -16,   38 },
    {   57,    3,    7,   -1,  -51,    5,  -27,  262 },
    {  -79,  244,  -22,    2,  -96,    8,  -15,  212 },
    {  -51,   26,  241,  -25,  -88,    6,  -23,  146 },
    {  -15,  -13,  -51,  264,  -42,   -5,  -38,   82 }
  },
  {
    {  218,  -56,    9,   -3,  411,  -76,   12,   -4 },
    {  448,   94,  -45,    6,   23,  -15,    2,   -3 },
    {   -1,  476,   77,  -34,   -5,   -2,    1,   -3 },
    {    1,  -16,  466,   61,    5,   -4,    1,   -3 },
    {  -38,    2,   -3,    0,  260,  358,  -77,    8 },
    {  122,  -39,    1,   -1,  463,  -25,  -11,   -2 },
    {  405,   54,  -41,    5,  121,  -33,    2,   -6 },
    {  107,  402,   16,  -12,    3,   -4,    1,   -6 },
    {    5,   -1,   -1,    0,  -62,  267,  375,  -73 },
    {  -25,    3,   -4,   -1,  108,  466,  -28,  -11 },
    {   58,  -25,   -3,   -1,  418,   96,  -35,   -3 },
    {  301,   18,  -15,    5,  229,  -21,   -4,   -7 },
    {   -1,   -3,   -2,   -2,   24,  -95,  291,  297 },
    {    3,    1,   -5,   -2,  -30,  103,  464,  -29 },
    {  -16,    0,   -6,    0,   41,  429,   70,  -13 },
    {   27,   -5,   -2,    1,  303,  193,  -13,   -1 }
  },
  {
    {  -48,   38,    6,   23,  120,  145,  -34,    6 },
    {  -27,   25,   32,   56,  -15,  217,  -34,    1 },
    {   -3,    8,    3,  133, -111,  223,   11,  -11 },
    {   10,    6,  -26,  183, -148,  163,   67,   -6 },
    {    7,    4,    1,   25,  -69,  155,  160,  -30 },
    {   -3,    9,   -2,   58,  -70,   42,  239,  -23 },
    {   -7,   16,  -23,  102,  -75,  -38,  239,   32 },
    {   -7,   18,  -22,  120,  -85,  -62,  168,  113 },
    {   -2,    4,   -1,   19,  -18,  -39,  160,  129 },
    {   -8,    8,   -9,   51,  -43,  -18,   37,  226 },
    {  -11,   12,  -20,   81,  -65,   -3,  -45,  287 },
    {  -12,   12,  -17,   93,  -80,    2,  -72,  302 },
    {   -5,    1,   -6,   21,  -18,    7,  -84,  326 },
    {  -14,    5,  -13,   45,  -33,   -6,  -79,  322 },
    {  -20,    6,  -13,   64,  -46,  -17,  -67,  311 },
    {  -20,    6,  -14,   78,  -56,  -23,  -57,  297 }
  },
  {
    {  -11,  -15,    6,    0,  286,  -10,    0,   -1 },
    {   86,  -29,   -9,    2,  242,  -44,   13,   -5 },
    {  104,   64,  -28,   -8,  157,  -42,   14,   -6 },
    {   92,   71,   72,  -38,   77,  -26,   11,   -6 },
    {    2,    1,    0,   -1,  -23,  291,  -12,   -3 },
    {  -24,    4,    1,   -1,   58,  259,  -49,    5 },
    {  -32,   -9,    3,    0,  155,  178,  -46,    5 },
    {  -20,    0,  -10,    3,  212,   93,  -28,    1 },
    {   -4,   -1,    0,    0,    4,  -23,  291,  -13 },
    {    2,   -2,    1,   -2,  -21,   58,  254,  -38 },
    {    5,   -1,    1,   -2,  -43,  157,  168,  -34 },
    {    2,    0,    4,   -4,  -35,  222,   82,  -19 },
    {    3,   -3,    1,   -1,   -3,    0,  -26,  283 },
    {    0,   -2,    0,   -1,    6,  -29,   62,  217 },
    {   -2,   -1,    1,   -2,   14,  -59,  171,  130 },
    {   -3,    1,    1,   -2,   14,  -56,  238,   58 }
  },
  {
    {  -84,   52,   -6,    0,  255,   63,  -38,   12 },
    { -207,  168,   29,   -8,  218,   82,  -42,   13 },
    { -179,   -9,  206,   -3,  162,  107,  -46,   12 },
    { -143,   13,  -61,  252,   98,  124,  -42,   10 },
    {   10,    1,    3,   -2,  -78,  245,  116,  -42 },
    {    2,    5,    3,   -1,  -69,  207,  151,  -47 },
    {  -10,    2,   18,   -6,  -63,  171,  188,  -51 },
    {  -19,   -2,  -14,   40,  -56,  133,  209,  -47 },
    {   -4,    1,    0,    0,   21,  -73,  226,   83 },
    {   -3,    3,   -2,   -1,   18,  -65,  189,  114 },
    {   -3,    2,   -2,   -1,   17,  -60,  152,  146 },
    {   -4,    1,    0,    1,   13,  -50,  120,  170 },
    {    2,   -1,    0,   -1,  -10,   26,  -74,  311 },
    {   -1,    3,   -1,   -1,  -12,   24,  -68,  306 },
    {    1,    0,    2,    0,  -14,   25,  -66,  303 },
    {    0,   -1,    1,    4,  -14,   24,  -58,  294 }
  },
  {
    {  -73,   -7,   -2,    8,  320,   17,  -11,    3 },
    {  -40,  -37,   -1,   12,  319,   10,   -9,    2 },
    {  -48,   -7,  -27,   17,  321,    5,   -7,    1 },
    {  -54,  -10,   -1,    8,  314,    4,   -6,    1 },
    {   22,   -1,   -1,    4,  -91,  308,   32,  -16 },
    {   13,    3,   -2,    7,  -82,  306,   25,  -14 },
    {   15,   -7,    2,   10,  -79,  308,   21,  -14 },
    {   13,   -7,   -6,   17,  -71,  303,   19,  -13 },
    {  -10,   -1,   -1,    3,   29,  -90,  299,   28 },
    {  -11,   -2,   -2,    6,   26,  -82,  297,   23 },
    {  -10,   -6,   -2,   10,   26,  -81,  299,   20 },
    {  -10,   -7,   -5,   14,   24,  -75,  294,   19 },
    {    2,    1,   -1,    3,  -12,   27,  -86,  321 },
    {   -2,    1,   -1,    7,  -10,   25,  -78,  314 },
    {   -3,   -3,   -1,   12,  -10,   25,  -77,  313 },
    {   -4,   -4,   -5,   18,   -9,   23,  -71,  307 }
  },
  {
    {  -91,   23,   13,    8,  209,  261,   72,   24 },
    {  -26,  -22,   14,   13,   88,  306,  114,   35 },
    {  -16,   18,  -16,    5,   31,  327,  135,   39 },
    {  -11,   11,   30,  -19,    3,  325,  142,   41 },
    {   12,   -4,    1,    1,  -14,  273,  227,   26 },
    {    3,   10,   -3,   -5,    6,  231,  249,   34 },
    {    1,    8,    5,   -9,   10,  214,  262,   37 },
    {   -1,   11,    4,   -7,   15,  208,  259,   40 },
    {    5,    0,    4,   -4,    6,   92,  340,   78 },
    {    4,    6,    1,   -5,    6,  113,  329,   75 },
    {    2,   13,    2,   -8,    6,  123,  319,   75 },
    {    1,   13,    6,  -10,    9,  136,  303,   74 },
    {    6,    1,    4,   -5,    8,   38,  217,  252 },
    {    4,   10,    1,   -7,    9,   58,  313,  141 },
    {    3,   12,    4,   -8,   11,   70,  327,  114 },
    {    2,   14,    4,   -7,   14,   82,  314,  110 }
  },
  {
    {  103,   77,  -13,    1,   11,   78,   -2,    2 },
    {  -26,  221,   40,   -5,  -23,   34,    9,    5 },
    {   -2,  -29,  268,   12,  -22,   14,    9,    8 },
    {   -6,   12,  -76,  321,  -11,    1,    3,    2 },
    {   41,   64,   -7,    0,  -79,  176,   64,   -3 },
    {  -33,  204,   29,   -3,  -84,   81,   45,   17 },
    {   -9,  -10,  256,    1,  -49,   18,   17,   28 },
    {   -9,   10,  -68,  304,  -15,   -7,   -3,   18 },
    {   13,   54,   -5,    0,  -46,    2,  162,   75 },
    {  -50,  172,   27,   -3,  -87,   27,   75,   94 },
    {  -23,    4,  235,   -3,  -74,   21,    4,   82 },
    {  -15,    7,  -60,  281,  -30,    4,  -27,   44 },
    {    5,   46,   -2,    0,  -35,    2,  -18,  257 },
    {  -53,  132,   27,   -2,  -64,    3,   -6,  215 },
    {  -39,   12,  198,   -1,  -71,    5,  -13,  141 },
    {  -22,    2,  -47,  251,  -40,   -2,  -21,   64 }
  }
};
ALIGN_DATA( MEMORY_ALIGN_DEF_SIZE, const short mipBias8x8[10][16] )=
{
  {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 },
  {   0,   1,   0,  -1,   0,   1,   0,  -1,   1,   1,  -1,  -2,   2,   1,  -1,  -2 },
  {   0,   2,   0,  18,   0,   2,   8,  42,  -1,   1,  20,  76,   1,   5,  34,  99 },
  {   1,   2,   3,   1,   1,   3,   3,   3,   2,   4,   4,   4,   3,   5,   5,   5 },
  {   0,   0,   1,   4,   2,   4,   7,  11,   2,   9,  17,  22,  12,  23,  31,  37 },
  {   1,   1,   2,   3,   1,   2,   2,   3,   1,   3,   3,   3,   2,   2,   3,   4 },
  {   1,   2,   3,   4,   3,   4,   6,   8,   1,   3,   4,   4,   3,   5,   5,   6 },
  {   0,   1,   1,   1,   0,   0,   1,   1,   0,   0,   1,   1,   1,   1,   1,   1 },
  {  -7, -10, -11, -11, -10, -14, -17, -18, -11, -15, -19, -21, -10, -17, -21, -22 },
  {  -1,  -1,  -3,  -1,   0,  -1,  -5,   2,  -1,  -1,  -5,   6,   0,  -2,  -4,  10 }
};
const int mipShiftBias8x8[10] =
{
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9
};
const int mipShiftMatrix8x8[10] =
{
  8, 8, 8, 9, 8, 8, 8, 8, 9, 8
};
ALIGN_DATA( MEMORY_ALIGN_DEF_SIZE, const short mipMatrix16x16[6][64][8] )=
{
  {
    {  -44,   32,   26,    9,  248,  -21,    9,   -3 },
    {  -51,   11,   43,   34,  214,    2,    6,   -3 },
    {  -27,  -28,   50,   66,  159,   36,    2,   -2 },
    {  -11,  -35,   33,  100,  101,   73,   -3,   -1 },
    {   -8,   -6,   -8,  131,   50,  105,   -8,    0 },
    {   -5,   15,  -26,  145,    3,  132,  -10,    2 },
    {    0,   17,   -4,  130,  -35,  155,  -11,    2 },
    {    7,   15,   12,  118,  -60,  167,   -8,    4 },
    {  -15,  -19,   -3,   22,  112,  171,  -13,    0 },
    {   -7,  -17,  -14,   35,   73,  200,  -13,    1 },
    {   -6,   -8,  -24,   42,   41,  221,  -13,    2 },
    {   -5,   -3,  -24,   43,   18,  234,  -10,    2 },
    {   -2,   -4,  -17,   41,    0,  239,   -4,    2 },
    {   -1,   -3,  -13,   41,  -16,  240,    4,    2 },
    {   -1,    1,  -14,   46,  -27,  232,   15,    2 },
    {   -2,    4,  -15,   52,  -35,  216,   29,    4 },
    {    2,    0,  -13,   14,   -5,  252,    2,    5 },
    {    2,    0,  -14,   17,  -12,  248,   10,    4 },
    {    2,   -1,  -14,   18,  -13,  232,   30,    2 },
    {    1,   -2,  -13,   18,  -14,  212,   53,   -1 },
    {    0,   -1,  -13,   17,  -13,  189,   79,   -5 },
    {   -2,    0,  -12,   18,  -13,  163,  107,   -7 },
    {   -2,    0,  -11,   18,  -13,  135,  132,   -6 },
    {   -2,    0,  -11,   20,  -13,  111,  147,    1 },
    {    2,    1,   -6,    8,  -16,  151,  120,   -5 },
    {    1,    1,   -6,    8,  -12,  118,  153,   -8 },
    {    0,    1,   -7,    9,   -8,   87,  180,   -7 },
    {    0,    0,   -8,    9,   -6,   64,  199,   -5 },
    {   -1,    0,   -8,    9,   -4,   43,  212,    1 },
    {   -2,    0,   -9,   10,   -3,   27,  218,   11 },
    {   -2,    0,   -9,   12,   -3,   18,  211,   25 },
    {   -2,    0,   -9,   14,   -4,   15,  196,   42 },
    {    0,    1,   -3,    4,   -3,   11,  236,    9 },
    {    0,    1,   -4,    4,   -1,   -1,  234,   21 },
    {    0,    0,   -5,    6,   -2,   -3,  214,   43 },
    {   -1,    0,   -6,    8,   -3,   -4,  193,   65 },
    {    0,    0,   -6,    9,   -4,   -3,  171,   87 },
    {   -1,    0,   -7,   10,   -5,   -2,  146,  110 },
    {   -1,    0,   -8,   13,   -5,    1,  122,  131 },
    {   -1,    0,   -9,   14,   -7,    5,  102,  148 },
    {    0,    1,   -2,    3,   -1,  -12,  142,  125 },
    {   -1,    1,   -3,    4,   -2,   -9,  111,  153 },
    {   -1,    1,   -4,    7,   -4,   -5,   84,  176 },
    {   -1,    0,   -4,    8,   -5,   -3,   63,  195 },
    {   -1,    0,   -6,   10,   -6,   -2,   45,  212 },
    {   -2,    0,   -7,   13,   -7,    0,   30,  225 },
    {   -2,    0,   -8,   15,   -8,    1,   20,  233 },
    {   -2,    0,   -8,   16,  -10,    3,   17,  235 },
    {   -1,    0,   -2,    3,   -1,   -2,    4,  253 },
    {   -1,    0,   -3,    5,   -2,   -2,   -6,  263 },
    {   -2,    0,   -4,    8,   -3,   -3,  -10,  268 },
    {   -2,    0,   -5,   10,   -4,   -4,  -14,  272 },
    {   -3,    0,   -7,   13,   -5,   -5,  -17,  276 },
    {   -3,    0,   -9,   16,   -6,   -6,  -18,  278 },
    {   -3,    0,   -9,   17,   -8,   -6,  -18,  278 },
    {   -3,    0,   -9,   18,   -9,   -5,  -16,  275 },
    {   -1,   -1,   -3,    5,    0,   -6,  -35,  294 },
    {   -1,   -1,   -3,    6,   -2,   -6,  -33,  293 },
    {   -2,   -1,   -5,   10,   -3,   -8,  -32,  293 },
    {   -1,   -2,   -6,   12,   -4,   -9,  -32,  294 },
    {   -2,   -1,   -7,   14,   -5,  -10,  -31,  294 },
    {   -3,    0,   -9,   17,   -6,  -11,  -30,  292 },
    {   -3,    1,  -10,   18,   -8,  -11,  -28,  291 },
    {   -3,    1,  -10,   19,   -8,  -11,  -25,  286 }
  },
  {
    {   78,   15,    0,    0,  158,    7,    0,   -2 },
    {  117,   35,    2,   -1,   96,    9,    0,   -2 },
    {  115,   72,    9,   -1,   55,    7,    1,   -2 },
    {   75,  116,   26,   -1,   36,    4,    3,   -2 },
    {   41,  117,   71,    0,   24,    2,    3,   -2 },
    {   28,   62,  138,   12,   14,    1,    3,   -1 },
    {   22,   14,  140,   69,    8,    1,    3,   -2 },
    {   16,   10,   34,  188,    7,    2,    1,   -1 },
    {   18,    5,    1,    0,  171,   64,   -1,   -2 },
    {   51,   11,    2,    0,  158,   37,    1,   -3 },
    {   81,   28,    1,    0,  123,   24,    1,   -3 },
    {   96,   51,    5,    1,   89,   15,    3,   -3 },
    {   89,   78,   19,    0,   63,    8,    3,   -3 },
    {   69,   94,   44,    2,   43,    4,    3,   -3 },
    {   51,   78,   86,   10,   29,    3,    3,   -3 },
    {   38,   49,   98,   47,   21,    3,    3,   -3 },
    {    5,    1,    1,    0,   83,  162,    5,   -2 },
    {   16,    2,    1,    1,  123,  112,    4,   -3 },
    {   37,    8,    1,    1,  135,   74,    3,   -3 },
    {   60,   19,    1,    1,  127,   49,    3,   -4 },
    {   77,   38,    4,    0,  107,   32,    2,   -3 },
    {   80,   61,   11,    1,   84,   21,    2,   -4 },
    {   72,   76,   30,    2,   63,   14,    2,   -4 },
    {   59,   72,   55,   11,   48,   12,    3,   -4 },
    {    3,   -1,    0,    1,   19,  178,   61,   -4 },
    {    5,   -1,    0,    1,   55,  166,   33,   -4 },
    {   13,    1,   -1,    1,   90,  134,   20,   -4 },
    {   28,    6,   -1,    1,  109,  105,   11,   -4 },
    {   45,   15,    0,    1,  114,   78,    7,   -4 },
    {   59,   31,    2,    1,  107,   57,    4,   -5 },
    {   64,   49,    9,    1,   92,   43,    3,   -5 },
    {   62,   59,   23,    5,   74,   34,    3,   -5 },
    {    1,   -2,    1,    0,    7,   87,  167,   -6 },
    {    1,   -2,    0,    1,   22,  129,  112,   -6 },
    {    3,   -2,    0,    1,   45,  145,   70,   -5 },
    {   10,    0,   -1,    1,   68,  140,   44,   -6 },
    {   21,    4,    0,    1,   87,  123,   27,   -6 },
    {   33,   13,    0,    1,   96,  103,   16,   -7 },
    {   44,   27,    2,    2,   94,   83,   11,   -6 },
    {   48,   38,   10,    4,   85,   67,   10,   -6 },
    {    0,   -1,    1,    0,    5,   11,  205,   36 },
    {   -2,   -1,    0,    0,    9,   55,  183,   11 },
    {   -3,   -1,    0,    0,   19,   98,  142,    1 },
    {    0,   -2,    0,    0,   35,  125,  103,   -4 },
    {    6,   -2,    0,    1,   51,  134,   72,   -6 },
    {   15,    2,    0,    2,   66,  129,   49,   -7 },
    {   25,   11,    0,    3,   75,  116,   34,   -7 },
    {   32,   21,    4,    4,   76,   98,   27,   -6 },
    {    0,   -1,    0,    0,    1,    4,   91,  161 },
    {   -2,   -1,   -1,    0,    3,   18,  146,   91 },
    {   -4,   -2,   -1,    1,    8,   46,  164,   44 },
    {   -6,   -3,    0,    1,   17,   77,  151,   17 },
    {   -3,   -4,    1,    1,   29,  102,  125,    4 },
    {    3,   -3,    0,    3,   41,  116,   98,   -2 },
    {   10,    2,    0,    4,   52,  119,   74,   -4 },
    {   16,   10,    3,    5,   59,  109,   57,   -2 },
    {    0,   -2,   -1,    0,    1,   14,  -26,  269 },
    {   -2,   -2,   -1,    0,    1,   17,   33,  208 },
    {   -4,   -2,   -1,    1,    3,   27,   93,  139 },
    {   -5,   -3,    0,    1,    9,   44,  129,   82 },
    {   -5,   -4,    1,    2,   16,   65,  135,   47 },
    {   -2,   -4,    1,    3,   25,   83,  125,   26 },
    {    2,   -2,    1,    4,   35,   94,  106,   15 },
    {    7,    3,    2,    6,   42,   96,   87,   12 }
  },
  {
    {   71,   17,    6,    4,  135,   11,    8,    4 },
    {   45,   82,    4,    9,   69,   33,   10,    4 },
    {  -13,  144,   15,   16,   35,   41,   13,    5 },
    {  -29,  103,   86,   16,   16,   44,   16,    5 },
    {  -18,   22,  149,   34,    1,   42,   19,    7 },
    {  -11,   -6,  103,  111,   -8,   37,   25,    8 },
    {   -9,   -3,   22,  190,  -13,   26,   33,   10 },
    {   -4,   -1,   -8,  215,  -17,   13,   40,   20 },
    {   -9,   20,   10,    6,  106,  117,   -3,    9 },
    {  -11,   41,   16,   17,   55,  120,    9,   11 },
    {  -22,   58,   25,   29,   13,  119,   20,   14 },
    {  -24,   43,   49,   43,  -11,  108,   34,   16 },
    {  -18,   12,   66,   66,  -25,   88,   49,   18 },
    {  -12,   -4,   45,  110,  -32,   64,   64,   23 },
    {   -8,   -6,   11,  150,  -34,   38,   74,   32 },
    {   -4,   -6,   -3,  164,  -34,   17,   74,   49 },
    {   -9,    8,    9,   10,   11,  203,    8,   16 },
    {  -12,   13,   13,   23,   -6,  173,   33,   20 },
    {  -13,   14,   16,   38,  -20,  137,   62,   24 },
    {  -13,    9,   20,   54,  -30,  100,   88,   29 },
    {  -10,    2,   20,   71,  -36,   67,  105,   38 },
    {   -8,   -3,   11,   93,  -39,   39,  112,   51 },
    {   -6,   -5,    2,  109,  -38,   17,  104,   73 },
    {   -3,   -6,    0,  115,  -36,    2,   85,   99 },
    {   -3,   -1,    6,   14,  -16,  134,  112,   11 },
    {   -5,   -2,    6,   26,  -18,   94,  131,   23 },
    {   -7,    0,    4,   38,  -21,   60,  142,   39 },
    {   -7,    0,    3,   51,  -25,   36,  140,   59 },
    {   -5,   -2,    3,   60,  -28,   19,  126,   84 },
    {   -4,   -2,   -1,   70,  -30,    6,  106,  112 },
    {   -3,   -3,   -2,   77,  -31,   -5,   85,  137 },
    {   -2,   -4,   -2,   82,  -31,  -10,   66,  156 },
    {   -1,   -3,    1,   15,   -8,   25,  198,   29 },
    {   -1,   -4,   -1,   25,  -12,   14,  174,   61 },
    {   -3,   -2,   -5,   35,  -15,    7,  142,   96 },
    {   -3,   -1,   -6,   42,  -19,    1,  113,  128 },
    {   -1,   -2,   -4,   46,  -22,   -4,   86,  157 },
    {   -1,   -1,   -4,   51,  -23,   -9,   65,  178 },
    {    0,   -1,   -4,   55,  -25,  -13,   48,  195 },
    {    0,   -2,   -3,   59,  -26,  -14,   35,  205 },
    {    1,   -4,   -3,   13,   -6,   -5,  141,  119 },
    {    1,   -3,   -7,   22,  -10,   -6,  105,  153 },
    {   -1,    0,  -11,   29,  -12,   -8,   75,  182 },
    {   -1,    0,   -9,   33,  -14,  -11,   53,  204 },
    {    0,   -1,   -6,   34,  -17,  -13,   35,  221 },
    {    0,   -1,   -5,   36,  -19,  -15,   22,  234 },
    {    1,   -1,   -4,   39,  -20,  -18,   13,  243 },
    {    2,   -1,   -2,   42,  -22,  -18,    7,  246 },
    {    2,   -2,   -6,   11,   -4,   -6,   39,  222 },
    {    1,   -1,  -11,   18,   -7,   -9,   24,  239 },
    {    0,    2,  -13,   23,   -8,  -12,   13,  250 },
    {   -1,    2,  -10,   24,  -11,  -14,    4,  260 },
    {    0,    0,   -6,   24,  -12,  -17,   -3,  267 },
    {    0,   -1,   -3,   25,  -14,  -19,  -10,  273 },
    {    1,   -1,   -2,   27,  -15,  -21,  -13,  275 },
    {    2,   -1,   -2,   31,  -18,  -22,  -13,  272 },
    {    2,   -1,   -8,    9,   -3,   -7,  -12,  274 },
    {    2,    0,  -11,   14,   -4,  -11,  -15,  279 },
    {    0,    3,  -11,   16,   -6,  -15,  -18,  283 },
    {   -2,    4,   -9,   17,   -7,  -16,  -21,  286 },
    {   -1,    1,   -5,   17,   -8,  -18,  -23,  288 },
    {   -1,    0,   -3,   18,  -10,  -20,  -24,  289 },
    {    0,    0,   -2,   21,  -12,  -21,  -25,  288 },
    {    1,   -1,   -2,   26,  -14,  -21,  -24,  284 }
  },
  {
    {  -21,   97,  -12,   -3,  185,   15,   -5,    0 },
    {  -40,  153,   13,   -5,   68,   87,  -21,    2 },
    {  -17,   83,   97,   -4,    4,  110,  -14,   -3 },
    {    3,   -3,  157,   22,  -15,   83,   19,  -10 },
    {    4,  -14,  102,   98,  -14,   41,   50,   -9 },
    {    3,   -3,   21,  172,  -10,   10,   61,    3 },
    {    2,    1,   -1,  188,   -7,  -11,   58,   27 },
    {    4,    3,    1,  173,   -7,  -23,   46,   58 },
    {  -31,   47,   24,   -4,   56,  198,  -40,    6 },
    {   -3,    9,   71,    5,   -6,  187,   -5,   -2 },
    {    6,  -16,   79,   40,  -19,  117,   57,   -7 },
    {    6,  -13,   40,   91,  -15,   47,   97,    4 },
    {    5,   -7,    9,  124,  -11,    5,  101,   31 },
    {    4,   -1,   -7,  135,  -10,  -16,   87,   63 },
    {    4,    5,  -11,  132,   -9,  -25,   64,   97 },
    {    6,    6,   -5,  121,  -10,  -27,   39,  125 },
    {    8,  -10,   34,    6,  -24,  217,   27,   -2 },
    {    9,  -21,   35,   35,  -18,  111,  109,   -5 },
    {    6,  -13,   10,   70,  -11,   34,  142,   18 },
    {    5,   -4,   -8,   89,   -8,   -3,  126,   59 },
    {    3,    1,  -12,   93,   -7,  -17,   96,   99 },
    {    3,    4,  -11,   91,   -8,  -22,   65,  134 },
    {    4,    5,   -7,   85,   -9,  -25,   40,  161 },
    {    4,    6,   -2,   81,  -10,  -23,   23,  175 },
    {    8,  -14,   11,   21,  -12,   71,  181,  -10 },
    {    4,  -10,   -4,   47,   -4,   12,  180,   31 },
    {    3,   -3,  -14,   62,   -2,   -8,  133,   87 },
    {    3,    0,  -16,   65,   -4,  -14,   86,  135 },
    {    3,    3,  -13,   63,   -5,  -17,   52,  170 },
    {    2,    4,   -8,   60,   -7,  -19,   29,  193 },
    {    2,    5,   -4,   56,   -8,  -19,   16,  204 },
    {    2,    4,    0,   56,   -8,  -18,   11,  206 },
    {    3,   -5,   -9,   26,   -1,   -4,  198,   47 },
    {    2,   -2,  -16,   40,   -1,  -10,  127,  116 },
    {    1,    1,  -18,   45,   -2,  -11,   70,  169 },
    {    2,    2,  -15,   45,   -4,  -12,   37,  199 },
    {    2,    2,  -10,   43,   -6,  -12,   18,  216 },
    {    3,    3,   -6,   41,   -9,  -13,    8,  226 },
    {    2,    4,   -3,   40,  -10,  -13,    3,  229 },
    {    2,    4,   -1,   41,  -10,  -13,    2,  226 },
    {    1,    0,  -13,   21,   -1,   -5,   96,  158 },
    {    2,    1,  -16,   29,   -3,   -5,   44,  204 },
    {    1,    2,  -16,   31,   -3,   -6,   19,  226 },
    {    1,    2,  -12,   30,   -5,   -7,    7,  236 },
    {    1,    2,   -7,   29,   -7,   -8,    2,  241 },
    {    1,    2,   -4,   28,   -9,   -9,   -2,  243 },
    {    1,    3,   -2,   28,  -10,  -10,   -3,  243 },
    {    2,    3,    0,   29,  -11,   -9,   -3,  239 },
    {    0,    2,  -13,   15,   -2,   -2,   22,  233 },
    {    0,    3,  -14,   19,   -3,   -2,    4,  247 },
    {    1,    3,  -12,   20,   -5,   -3,   -1,  251 },
    {    1,    1,   -8,   19,   -6,   -5,   -3,  252 },
    {    1,    1,   -4,   19,   -8,   -6,   -3,  251 },
    {    2,    1,   -2,   18,  -10,   -6,   -4,  251 },
    {    1,    2,    0,   19,  -11,   -7,   -5,  249 },
    {    1,    2,    0,   21,  -11,   -8,   -2,  243 },
    {    0,    3,  -11,    8,   -1,   -1,   -1,  255 },
    {    0,    3,  -11,   11,   -4,   -1,   -3,  256 },
    {    0,    3,   -9,   12,   -5,   -2,    0,  253 },
    {    0,    2,   -5,   12,   -6,   -4,   -1,  252 },
    {    0,    1,   -3,   13,   -7,   -5,   -1,  251 },
    {    0,    2,   -1,   14,   -9,   -5,   -2,  249 },
    {    0,    2,    0,   15,   -9,   -5,   -3,  247 },
    {    1,    1,    1,   17,   -9,   -6,   -3,  242 }
  },
  {
    {  -34,   16,    3,    2,  306,  -45,    8,    1 },
    {  -35,   15,    4,    4,  303,  -44,    8,    0 },
    {  -35,   13,    6,    4,  303,  -43,    8,    0 },
    {  -38,   13,    9,    4,  301,  -42,    7,    0 },
    {  -43,   20,    6,    7,  299,  -41,    7,    0 },
    {  -48,   20,   11,    9,  295,  -39,    7,    0 },
    {  -53,   13,   30,    6,  290,  -36,    6,    0 },
    {  -59,    8,   27,   26,  278,  -32,    6,    1 },
    {  -38,    1,   -1,    0,  213,  104,  -25,    3 },
    {  -40,    2,   -1,    0,  216,   99,  -23,    3 },
    {  -44,    7,   -2,    1,  215,  101,  -24,    3 },
    {  -45,    6,   -1,    1,  214,  102,  -24,    3 },
    {  -43,    1,    4,    0,  212,  103,  -24,    3 },
    {  -43,    0,    3,    2,  210,  105,  -24,    2 },
    {  -43,    2,   -1,    6,  208,  106,  -24,    2 },
    {  -44,    3,    0,    6,  203,  107,  -23,    3 },
    {   -1,   -2,   -1,   -1,    8,  285,  -36,    3 },
    {   -1,   -2,    0,    0,    8,  285,  -37,    4 },
    {   -2,   -1,    0,    0,    7,  286,  -37,    3 },
    {   -2,   -2,    1,    0,    7,  286,  -36,    3 },
    {   -2,   -3,    1,    0,    7,  285,  -35,    3 },
    {   -3,   -3,    1,    1,    7,  284,  -34,    3 },
    {   -3,   -4,    1,    2,    8,  281,  -32,    2 },
    {   -5,   -3,    1,    3,   10,  275,  -28,    2 },
    {   10,   -3,    0,   -1,  -42,  203,  111,  -22 },
    {    9,   -2,    1,    0,  -42,  204,  108,  -21 },
    {    8,   -1,    0,    0,  -41,  200,  111,  -22 },
    {    8,   -1,    0,    0,  -40,  199,  113,  -22 },
    {    7,   -3,    2,    0,  -39,  196,  115,  -22 },
    {    7,   -3,    2,    1,  -39,  194,  116,  -22 },
    {    7,   -3,    1,    1,  -37,  191,  118,  -22 },
    {    6,   -3,    2,    2,  -35,  186,  119,  -21 },
    {    2,   -1,    0,    0,   -4,    8,  277,  -27 },
    {    1,    0,    0,    0,   -4,    7,  279,  -28 },
    {    0,    1,    0,    0,   -4,    6,  279,  -27 },
    {    0,    1,    1,    0,   -3,    6,  278,  -26 },
    {   -1,    0,    1,    1,   -4,    6,  278,  -25 },
    {   -1,    0,    1,    1,   -4,    6,  276,  -24 },
    {   -1,   -1,    1,    2,   -4,    7,  274,  -22 },
    {   -1,   -1,    2,    3,   -4,    9,  267,  -18 },
    {    0,   -1,    0,    0,    6,  -39,  207,   81 },
    {   -1,    0,    0,    0,    7,  -38,  207,   81 },
    {   -2,    1,    0,    0,    6,  -37,  205,   83 },
    {   -2,    1,    1,    0,    6,  -37,  203,   84 },
    {   -2,    0,    2,    0,    6,  -36,  201,   86 },
    {   -2,    0,    2,    1,    6,  -36,  199,   87 },
    {   -3,    0,    1,    2,    6,  -35,  197,   89 },
    {   -3,    0,    2,    2,    5,  -33,  192,   91 },
    {    0,    0,    0,    0,    1,   -4,   15,  244 },
    {    0,    0,    0,    0,    1,   -3,   14,  245 },
    {   -1,    1,    0,   -1,    1,   -4,   13,  246 },
    {   -2,    1,    1,   -1,    1,   -4,   13,  246 },
    {   -2,    0,    2,   -1,    1,   -4,   12,  247 },
    {   -2,    0,    2,    0,    1,   -4,   12,  246 },
    {   -2,    0,    2,    1,    1,   -5,   13,  246 },
    {   -3,    0,    2,    2,    1,   -4,   15,  243 },
    {    1,    0,   -1,    0,   -2,   10,  -67,  314 },
    {   -1,    1,    0,    0,   -2,    9,  -62,  310 },
    {   -1,    2,    0,    0,   -2,    9,  -63,  311 },
    {   -2,    2,    1,    0,   -2,    9,  -63,  311 },
    {   -2,    1,    2,    0,   -2,    9,  -63,  310 },
    {   -2,    0,    2,    1,   -2,    9,  -62,  309 },
    {   -2,    0,    2,    2,   -2,    9,  -61,  308 },
    {   -3,    0,    2,    3,   -2,    9,  -59,  305 }
  },
  {
    {   58,   21,    7,    1,  168,    0,    1,    0 },
    {   16,   99,    5,    3,  126,    6,    1,    0 },
    {  -58,  186,   15,    4,   98,    9,    1,    0 },
    {  -87,  163,   91,   -2,   79,   11,    0,    0 },
    {  -72,   59,  186,    7,   63,   12,    0,    1 },
    {  -57,    9,  160,   81,   49,   12,    0,    1 },
    {  -50,   11,   45,  196,   39,   13,    0,    1 },
    {  -47,   15,  -21,  260,   32,   14,    0,    2 },
    {  -35,   35,    6,    2,  165,   92,  -10,    0 },
    {  -80,   89,   13,    5,  159,   76,   -5,   -2 },
    { -135,  150,   26,    8,  143,   70,   -3,   -2 },
    { -161,  141,   81,    8,  127,   63,   -3,   -2 },
    { -154,   74,  148,   21,  112,   57,   -2,   -2 },
    { -138,   32,  132,   83,   97,   52,   -1,   -1 },
    { -123,   24,   49,  177,   80,   50,    0,   -1 },
    { -109,   22,   -4,  233,   64,   48,    1,    1 },
    {  -32,   28,    7,    3,   33,  228,  -12,    1 },
    {  -78,   65,   16,    7,   46,  211,  -11,   -1 },
    { -127,  103,   32,   12,   54,  192,   -8,   -2 },
    { -159,  100,   70,   18,   60,  175,   -6,   -2 },
    { -169,   64,  110,   35,   64,  158,   -5,   -2 },
    { -170,   38,   99,   86,   67,  141,   -2,   -2 },
    { -165,   29,   46,  157,   66,  124,    2,   -2 },
    { -154,   24,    7,  205,   60,  108,    6,   -1 },
    {  -25,   20,    9,    4,  -23,  202,   79,   -9 },
    {  -62,   44,   16,    9,  -20,  215,   60,   -7 },
    { -100,   66,   30,   16,  -16,  216,   50,   -7 },
    { -128,   64,   57,   24,  -12,  215,   42,   -6 },
    { -145,   44,   81,   43,   -7,  210,   36,   -7 },
    { -155,   30,   72,   84,   -2,  202,   30,   -5 },
    { -159,   24,   37,  138,    2,  190,   28,   -4 },
    { -157,   20,   10,  177,    6,  172,   28,   -2 },
    {  -25,   15,    8,    4,   -5,   47,  225,  -13 },
    {  -53,   31,   14,   11,   -8,   70,  207,  -15 },
    {  -82,   43,   25,   19,  -12,   91,  186,  -14 },
    { -104,   41,   44,   28,  -16,  110,  166,  -13 },
    { -119,   27,   58,   46,  -19,  126,  148,  -12 },
    { -130,   20,   50,   79,  -22,  139,  130,  -10 },
    { -139,   17,   26,  121,  -24,  148,  113,   -7 },
    { -143,   15,    8,  153,  -23,  150,   98,   -2 },
    {  -21,   10,    7,    4,    4,  -28,  225,   55 },
    {  -43,   21,   11,   11,    2,  -20,  234,   40 },
    {  -65,   28,   19,   20,   -1,   -9,  234,   30 },
    {  -81,   22,   32,   30,   -5,    3,  232,   22 },
    {  -93,   14,   41,   46,  -10,   16,  227,   15 },
    { -105,   10,   33,   74,  -14,   30,  216,   11 },
    { -115,    9,   16,  106,  -18,   44,  202,   11 },
    { -122,    8,    4,  132,  -21,   56,  183,   14 },
    {  -14,    8,    5,    3,   -3,   -8,   60,  205 },
    {  -32,   14,    7,   12,   -4,   -9,   82,  185 },
    {  -48,   16,   13,   21,   -5,  -10,  102,  165 },
    {  -60,   10,   23,   31,   -6,   -8,  120,  147 },
    {  -71,    4,   26,   47,   -9,   -7,  137,  129 },
    {  -82,    2,   18,   70,  -12,   -4,  150,  112 },
    {  -93,    3,    6,   95,  -13,   -1,  158,   99 },
    { -100,    3,   -2,  117,  -16,    6,  157,   91 },
    {  -12,    5,    3,    5,   -6,   15,  -69,  314 },
    {  -26,    9,    4,   14,   -6,   14,  -55,  302 },
    {  -37,    9,    8,   22,   -7,   12,  -42,  290 },
    {  -46,    3,   13,   33,   -9,   12,  -27,  277 },
    {  -55,   -2,   14,   47,  -11,   10,  -11,  262 },
    {  -65,   -2,    7,   66,  -12,   10,    6,  245 },
    {  -75,   -1,   -2,   87,  -13,    9,   23,  227 },
    {  -83,   -2,   -7,  105,  -15,   11,   34,  211 }
  }
};
ALIGN_DATA( MEMORY_ALIGN_DEF_SIZE, const short mipBias16x16[6][64] )=
{
  {  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  3,  1,  1,  2,  2,  2,  2,  3,  3,  1,  1,  2,  2,  2,  3,  3,  3,  1,  2,  2,  2,  3,  3,  3,  3,  1,  2,  2,  2,  2,  3,  3,  3,  1,  2,  2,  3,  3,  3,  4,  4,  2,  3,  3,  3,  4,  4,  5,  5 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },
  { -1, -1,  0,  0,  0, -1,  0,  1,  0, -1,  0,  0,  0,  0,  1,  2,  0,  0,  1,  1,  1,  2,  3,  4,  0,  1,  1,  2,  3,  4,  5,  6,  1,  2,  3,  4,  5,  6,  8,  9,  1,  3,  5,  7,  8, 10, 11, 12,  2,  5,  7, 10, 12, 13, 15, 15,  5,  8, 10, 12, 15, 16, 17, 18 },
  { -1, -1,  0,  0, -1, -1, -1, -1,  0,  0, -1, -1, -1, -2, -2, -2,  0,  0, -1, -1, -2, -2, -3, -3,  0, -1, -1, -2, -2, -3, -3, -3,  0, -1, -2, -2, -3, -3, -3, -3, -1, -1, -2, -2, -3, -3, -3, -4, -1, -2, -2, -3, -3, -4, -4, -3, -1, -2, -2, -3, -3, -3, -3, -3 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1, -1, -1,  0,  0,  0,  0,  0, -1, -1, -1,  0,  0,  0,  0,  0,  0,  0,  0 }
};
const int mipShiftBias16x16[6] =
{
  9, 9, 9, 9, 9, 9
};
const int mipShiftMatrix16x16[6] =
{
  8, 8, 8, 8, 8, 8
};
#endif